/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.bean;

import java.util.Objects;

/**
 *
 * @author tskoda
 */
public class Certificate {
    
    private final String id;
    private final boolean valid;
    private final String publicCert;
    private final String privateKey;

    public Certificate(String id, boolean valid, String publicCert, String privateKey) {
        this.id = id;
        this.valid = valid;
        this.publicCert = publicCert;
        this.privateKey = privateKey;
    }

    public String getId() {
        return id;
    }

    public String getPublicCert() {
        return publicCert;
    }

    public String getPrivateKey() {
        return privateKey;
    }

    public boolean isValid() {
        return valid;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 89 * hash + Objects.hashCode(this.id);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Certificate other = (Certificate) obj;
        if (!Objects.equals(this.id, other.id)) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "Certificate{" + "id=" + id + '}';
    }
    
}
