/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.common;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Classes marked with this annotation have to be manualy registered as
 * ServiceProviders for interfaces passed as arguments.
 * @author tskoda
 */
@Retention(RetentionPolicy.CLASS)
@Target(ElementType.TYPE)
public @interface RegisterAs {
    /**
     * List of interfaces registered by this service provider.
     * @return
     */
    Class<? extends Service>[] interfaces() default {};
}
