/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.common;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author development
 */
public class StopWatch {

    public static final Level PERF_LEVEL = new CustomLevel("PERF", Level.INFO.intValue() + 1);
    private static final double TOSEC = 1000 * 1000 * 1000;
    private long start;
    private double sum;
    private String name;
    private long count;

    public StopWatch(String name) {
        this.start = 0;
        this.sum = 0;
        this.name = name;
        this.count = 0;
    }

    public void start() {
        this.start = System.nanoTime();
    }

    public void stop() {
        this.sum = (System.nanoTime() - start) / TOSEC;
        this.count++;
    }

    public void stop(Logger log) {
        stop();
        if (this.sum > 0.0009) {
            log.log(PERF_LEVEL, toString());
        }
                
    }
    
    public double getSum() {
        return sum;
    }

    @Override
    public String toString() {
        return String.format(" | %1$15s | %2$9.3f | s | ", this.name, this.sum);
    }

    public long getCount() {
        return count;
    }

    public void resetCount() {
        this.count = 0;
    }
    
    
}
