package com.kerio.im.common;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import com.diffblue.deeptestutils.Reflector;
import java.io.File;
import java.io.IOException;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class FileUtilDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: FileUtil */
  // Test generated by Diffblue Deeptest.
  @PrepareForTest(File.class)
  @Test
  public void createParentInputNotNullOutputIOException() throws Exception {

    // Arrange
    final File outputFile = PowerMockito.mock(File.class);
    final File file = PowerMockito.mock(File.class);
    PowerMockito.when(file.exists()).thenReturn(false);
    PowerMockito.when(file.mkdir()).thenReturn(false);
    Reflector.setField(file, "prefixLength", 0);
    Reflector.setField(file, "path", "");
    PowerMockito.when(outputFile.getParentFile()).thenReturn(file);
    PowerMockito.when(outputFile.toString()).thenReturn("/");
    Reflector.setField(outputFile, "prefixLength", 0);
    Reflector.setField(outputFile, "path", "/");

    // Act
    thrown.expect(IOException.class);
    FileUtil.createParent(outputFile);

    // Method is not expected to return due to exception thrown
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(File.class)
  @Test
  public void createParentInputNotNullOutputNotNull() throws Exception {

    // Arrange
    final File outputFile = PowerMockito.mock(File.class);
    final File file = PowerMockito.mock(File.class);
    PowerMockito.when(file.exists()).thenReturn(false);
    PowerMockito.when(file.mkdir()).thenReturn(true);
    Reflector.setField(file, "prefixLength", 0);
    Reflector.setField(file, "path", "");
    PowerMockito.when(outputFile.getParentFile()).thenReturn(file);
    Reflector.setField(outputFile, "prefixLength", 0);
    Reflector.setField(outputFile, "path", "/");

    // Act
    final File retval = FileUtil.createParent(outputFile);

    // result
    assertNotNull(retval);
    assertEquals(0, Reflector.getInstanceField(retval, "prefixLength"));
    assertEquals("/", Reflector.getInstanceField(retval, "path"));
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(File.class)
  @Test
  public void createParentInputNotNullOutputNotNull3() throws Exception {

    // Arrange
    final File outputFile = PowerMockito.mock(File.class);
    final File file = PowerMockito.mock(File.class);
    PowerMockito.when(file.exists()).thenReturn(true);
    Reflector.setField(file, "prefixLength", 0);
    Reflector.setField(file, "path", "");
    PowerMockito.when(outputFile.getParentFile()).thenReturn(file);
    Reflector.setField(outputFile, "prefixLength", 0);
    Reflector.setField(outputFile, "path", "/");

    // Act
    final File retval = FileUtil.createParent(outputFile);

    // result
    assertNotNull(retval);
    assertEquals(0, Reflector.getInstanceField(retval, "prefixLength"));
    assertEquals("/", Reflector.getInstanceField(retval, "path"));
  }
}
