package com.kerio.im.common.error;

import static org.junit.Assert.assertEquals;

import com.diffblue.deeptestutils.Reflector;
import com.diffblue.deeptestutils.mock.DTUMemberMatcher;
import java.lang.reflect.Method;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class ServiceExceptionDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: ServiceException */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getIntCodeOutputPositive() throws Exception {

    // Arrange
    final ServiceException objectUnderTest =
        (ServiceException) Reflector.getInstance("com.kerio.im.common.error.ServiceException");
    Reflector.setField(objectUnderTest, "parameters", null);
    Reflector.setField(objectUnderTest, "code", Code.EXT_SERVICE_ERROR);
    Reflector.setField(objectUnderTest, "cause", null);
    Reflector.setField(objectUnderTest, "detailMessage", null);

    // Act
    final int retval = objectUnderTest.getIntCode();

    // result
    assertEquals(7, retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest({ServiceException.class, RuntimeException.class})
  @Test
  public void getMessageOutputNotNull() throws Exception {

    // Arrange
    final ServiceException objectUnderTest = PowerMockito.mock(ServiceException.class);
    PowerMockito.doCallRealMethod().when(objectUnderTest);
    objectUnderTest.getMessage();
    final Method getMessageMethod = DTUMemberMatcher.method(RuntimeException.class, "getMessage");
    PowerMockito.doReturn("").when(objectUnderTest, getMessageMethod).withNoArguments();
    Reflector.setField(objectUnderTest, "parameters", null);
    Reflector.setField(objectUnderTest, "code", null);
    Reflector.setField(objectUnderTest, "cause", null);
    Reflector.setField(objectUnderTest, "detailMessage", null);

    // Act
    final String retval = objectUnderTest.getMessage();

    // result
    assertEquals("", retval);
  }
}
