/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.common;

import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

/**
 *
 * @author tskoda
 */
public class InetAddressUtilTest {
    
    public InetAddressUtilTest() {
    }

    @Test
    public void testCombineUrl() {
        assertThat(InetAddressUtil.combineURL(null, null), is(""));
        assertThat(InetAddressUtil.combineURL(null, ""), is(""));
        assertThat(InetAddressUtil.combineURL(null, "/child"), is(""));
        assertThat(InetAddressUtil.combineURL(null, "child"), is(""));
        
        assertThat(InetAddressUtil.combineURL("", null), is(""));
        assertThat(InetAddressUtil.combineURL("http://root", null), is(""));
        assertThat(InetAddressUtil.combineURL("http://root/", null), is(""));
        
        assertThat(InetAddressUtil.combineURL("http://root/", "/child"), is("http://root/child"));
        assertThat(InetAddressUtil.combineURL("http://root", "/child"), is("http://root/child"));
        assertThat(InetAddressUtil.combineURL("http://root/", "child"), is("http://root/child"));
        assertThat(InetAddressUtil.combineURL("http://root", "child"), is("http://root/child"));
        
        assertThat(InetAddressUtil.combineURL("http://root////", "/////child"), is("http://root/child"));
    }
    
}
