/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.api.event;

import com.kerio.im.common.error.Code;
import com.kerio.im.core.api.service.ServiceBus;

/**
 * Class represent shutdown event distributed on system shutdown. Type of
 * shutdown and its reason is represented by Code member.
 * @author tskoda
 */
public class ShutdownEvent implements ServiceBus.Event {

    private final Code code;

    public ShutdownEvent(Code code) {
        this.code = code;
    }

    public Code getCode() {
        return code;
    }

    @Override
    public String toString() {
        return "ShutdownEvent{" + "code=" + code + '}';
    }
    
}
