/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.api.service;

/**
 *
 * @author tskoda
 */
public interface AccessPolicyService {

    /**
     * Check user permissions to receive packet from sender.
     *
     * @param from sender login
     * @param fromDomain sender domain
     * @param to recipient login
     * @param toDomain recipient domain
     * @return true if federation is enabled and user can send messages outside
     * domain
     */
    boolean incoming(String from, String fromDomain, String to, String toDomain, PacketType type);

    /**
     * Localized text returned to the user when communication is blocked.
     */
    String incomingResponse();

    /**
     * Check user permissions to send packet to recipient.
     *
     * @param to recipient login
     * @param toDomain recipient domain
     * @param from sender login
     * @param fromDomain sender domain
     * @return true if federation is enabled and user can send messages outside
     * domain
     */
    boolean outgoing(String to, String toDomain, String from, String fromDomain, PacketType type);

    /**
     * Localized text returned to the user when communication is blocked.
     */
    String outgoingResponse();
}
