/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.core.api.service;

/**
 *
 * @author tskoda
 */
public interface SecurityService {
    
    /**
     * Returns subset of defaultEnabledCiphers considered as safe.
     * @param protocol protocol which provider supports passed ciphers
     * @param defaultEnabledCiphers enabled ciphers by default by protocol provider
     * @return array of safe ciphers
     */
    String[] filterCiphers(String protocol, String[] defaultEnabledCiphers);

    /**
     * Returns subset of defaultEnabledProtocols considered as safe. Currently it means
     * everything stronger than SSLv3 (excluded).
     * @param protocol 
     * @param defaultEnabledProtocols enabled protocols by default by protocol provider
     * @return array of safe protocols
     */
    String[] filterProtocols(String[] defaultEnabledProtocols);
    
}
