/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.api.service;

import com.kerio.im.core.api.event.ShutdownEvent;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

/**
 *
 * @author tskoda
 */
public interface ThreadService {
    
    ShutdownListener submit(Runnable command, long initialDelay, TimeUnit unit);
    ShutdownListener submit(Runnable command, long initialDelay, long period, TimeUnit unit);
    
    class ShutdownListener implements ServiceBus.EventListener<ShutdownEvent> {

        private final ScheduledFuture<?> future;

        public ShutdownListener(ScheduledFuture<?> periodicUserSync) {
            this.future = periodicUserSync;
        }

        public ScheduledFuture<?> getFuture() {
            return future;
        }
        
        @Override
        public void event(ShutdownEvent event) {
            this.future.cancel(true);
        }
    }
}
