/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core;

import java.util.concurrent.ThreadFactory;

/**
 *
 * @author tskoda
 */
public class CustomThreadFactory implements ThreadFactory {
    
    private final String customThreadName;
    private final boolean daemon;
    private int count = 0;

    public CustomThreadFactory(String customThreadName, boolean daemon) {
        this.customThreadName = customThreadName;
        this.daemon = daemon;
    }

    @Override
    public Thread newThread(Runnable r) {
        Thread thread = new Thread(r, this.customThreadName + "-" + count++);
        thread.setDaemon(this.daemon);
        return thread;
    }
    
}
