/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core;

import com.kerio.im.core.api.service.ThreadService;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

/**I
 *
 * @author tskoda
 */
public class ThreadPool implements ThreadService {

    private static final String THREAD_NAME = "im-service-core";
    private static final int CORE_POOL_SIZE = 5;
    private final ScheduledExecutorService pool;
    private final CustomThreadFactory threadFactory;

    public ThreadPool() {
        this.threadFactory = new CustomThreadFactory(THREAD_NAME, true);
        this.pool = Executors.newScheduledThreadPool(CORE_POOL_SIZE, threadFactory);
    }

    public ShutdownListener submit(Runnable command, long initialDelay, long period, TimeUnit unit) {
        //TODO is it thread safe?
        ScheduledFuture<?> result = pool.scheduleAtFixedRate(command, initialDelay, period, unit);
        return new ShutdownListener(result);
    }
    
    public ShutdownListener submit(Runnable command, long initialDelay, TimeUnit unit) {
        //TODO is it thread safe?
        ScheduledFuture<?> result = pool.schedule(command, initialDelay, unit);
        return new ShutdownListener(result);
    }
    
}
