/*
 *  Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.conversation;

/**
 *
 * @author tskoda
 */
public interface ConversationStorage {

    interface SessionStorage {

        void say(String who, String what, String raw);

        void transfer(String who, String fileName, long size, String raw);
        
    }

    void close();

    /**
     * Returns latest room/chat session of specified room.
     *
     * @param room address of room
     * @return instance of SessionStorage, should not be cached
     */
    SessionStorage latest(String room);

    /**
     * Returns latest room/chat session of chat between two participants. Always
     * the same SessionStorage is returned no matter of participants order
     * passed.
     *
     * @param participant1 jabber id of first chat participant
     * @param participant2 jabber id of second chat participant
     * @return instance of SessionStorage, should not be cached
     */
    SessionStorage latest(String participant1, String participant2);

}
