/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.domain;

import com.kerio.im.bean.Domain;
import com.kerio.im.core.Bus;

/**
 *
 * @author tskoda
 */
public class DomainEvent implements Bus.Event {
    
    public enum Type {
        ADDED,
        REMOVED,
        FOUND,
        REPAIRED
    }
    
    private final Type type;
    private final Domain domain;

    public DomainEvent(Type type, Domain domain) {
        this.type = type;
        this.domain = domain;
    }

    public Type type() {
        return type;
    }

    public Domain domain() {
        return domain;
    }
}
