/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.service;

import com.kerio.im.bean.Port;
import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 *
 * @author tskoda
 */
public class FilterHost implements Port.Filter {
    private final InetAddress host;

    public FilterHost(String host) throws UnknownHostException {
        this.host = InetAddress.getByName(host);
    }
    
    public FilterHost(InetAddress host) {
        this.host = host;
    }

    @Override
    public boolean pass(InetAddress client) {
        return this.host.equals(client);
    }

    @Override
    public String toString() {
        return "FilterHost{" + "host=" + host + '}';
    }
    
}
