/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.user;

import com.kerio.im.core.api.service.ServiceBus;
import com.kerio.im.core.remote.CommandEvent;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author tskoda
 */
public class EventFederation implements ServiceBus.EventListener<CommandEvent> {

    private static final Logger LOG = Logger.getLogger(EventFederation.class.getName());
    private static final String MESSAGE = "settings";
    private final UserAccessPolicy accessPolicy;

    public EventFederation(UserAccessPolicy accessPolicy) {
        this.accessPolicy = accessPolicy;
    }

    @Override
    public void event(CommandEvent event) {
        if (!event.interested(MESSAGE)) {
            return;
        }

        try {
            boolean sendOutsideDomain = Boolean.valueOf(event.get("sendOutsideEnabled"));
            this.accessPolicy.setState(sendOutsideDomain? UserAccessPolicy.State.ENABLED: UserAccessPolicy.State.DISABLED);
        } catch (Exception e) {
            LOG.log(Level.WARNING, "Processing federation settings event failed", e);
            event.fail(e.getMessage());
        }
    }
}
