/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.user;

import com.kerio.im.core.ThreadPool;
import com.kerio.im.core.api.service.ConfigurationService;
import com.kerio.im.core.api.service.ServiceBus;
import com.kerio.im.core.api.service.UserService;
import com.kerio.im.core.domain.DomainEvent;
import com.kerio.im.core.remote.CommandEvent;
import com.kerio.im.external.ExtService;
import com.kerio.im.xmpp.api.XmppService;
import java.util.logging.Logger;

/**
 *
 * @author tskoda
 */
public class Users implements UserService {

    private static final Logger LOG = Logger.getLogger(Users.class.getName());
    //private static final int INITIAL_DELAY = Domains.INITIAL_DELAY + 5; //seconds, this value should be greater than initial sync of domains 

    private final UserControlList list;

    public Users(final ConfigurationService configuration, final XmppService xmppService, final ExtService extService, final ServiceBus bus, final ThreadPool threadPool) {
        this.list = new UserControlList(xmppService, extService);
        bus.subscribe(CommandEvent.class, new EventUserSync(this.list));
        bus.subscribe(DomainEvent.class, new EventDomainSync(this.list));
//        bus.subscribe(ShutdownEvent.class, threadPool.submit(
//                new FullSync(this.list),
//                configuration.get(GlobalKey.REFRESH_PERIOD_KEY),
//                configuration.get(GlobalKey.REFRESH_PERIOD_KEY),
//                TimeUnit.SECONDS));
//        LOG.log(Level.INFO, "User synchronization scheduled, it's about to start in {0} seconds", configuration.get(GlobalKey.REFRESH_PERIOD_KEY));
    }

    @Override
    public String[] getAdmins(String domain) {
        //TODO return admins for domain
        return new String[0];
    }

    @Override
    public long usersCount(String domain) {
        //TODO return count of users for domain
        return 0;
    }
    
    UserControl getControl(String domain) {
        return this.list.get(domain);
    }

    public boolean check(String userName, String domain) {
        boolean result = false;
        UserControl sync;
        if ((sync = getControl(domain)) != null) {
               result = sync.check(userName);
        }
        return result;
    }
}
