/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.vcard;

import com.kerio.im.bean.VCard;
import com.kerio.im.core.api.service.ServiceBus;
import com.kerio.im.core.api.service.VCardService;
import com.kerio.im.core.domain.DomainEvent;
import com.kerio.im.external.ExtService;
import com.kerio.im.xmpp.api.XmppService;
import java.util.logging.Logger;

/**
 *
 * @author tskoda
 */
public class VCards implements VCardService {
    private static final Logger LOG = Logger.getLogger(VCards.class.getName());
    private final VCardStore provider;
    
    public VCards(XmppService xmppService, ExtService extService, ServiceBus bus) {
        this.provider = new VCardStore(xmppService.vcardFactory(), extService);
        bus.subscribe(DomainEvent.class, new EventDomainSync(this.provider));
    }

    @Override
    public VCard get(String login, String domain) {
        //LOG.log(Level.FINE, "Getting vcard for user {0}@{1}", new Object[]{login, domain});
        return this.provider.get(login.toLowerCase(), domain.toLowerCase());
    }
    
    @Override
    public boolean enabled() {
        return true;
    }

}
