package com.kerio.im.core;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import com.diffblue.deeptestutils.Reflector;
import com.kerio.im.core.api.service.ServiceBus.Event;
import com.kerio.im.core.api.service.ServiceBus.EventListener;
import com.kerio.im.core.api.service.ServiceBus.ExceptionHandler;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class BusDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: Bus */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getListenersInputNullOutput0() throws Exception {

    // Arrange
    final Bus objectUnderTest = new Bus();
    final HashMap hashMap = new HashMap();
    hashMap.put(null, null);
    Reflector.setField(objectUnderTest, "subscribers", hashMap);
    final Class event = null;

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.Bus");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("getListeners", Reflector.forName("java.lang.Class"));
    methodUnderTest.setAccessible(true);
    final List retval = (List) methodUnderTest.invoke(objectUnderTest, event);

    // result
    final LinkedList linkedList = new LinkedList();
    assertEquals(linkedList, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getListenersInputNullOutput1() throws Exception {

    // Arrange
    final Bus objectUnderTest = new Bus();
    final HashMap hashMap = new HashMap();
    final ArrayList arrayList = new ArrayList();
    final EventListener eventListener =
        (EventListener)
            Reflector.getInstance("com.kerio.im.core.api.service.ServiceBus$EventListener");
    arrayList.add(eventListener);
    hashMap.put(null, arrayList);
    Reflector.setField(objectUnderTest, "subscribers", hashMap);
    final Class event = null;

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.Bus");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("getListeners", Reflector.forName("java.lang.Class"));
    methodUnderTest.setAccessible(true);
    final List retval = (List) methodUnderTest.invoke(objectUnderTest, event);

    // result
    assertNotNull(retval);
    assertEquals(1, retval.size());
    assertNotNull(retval.get(0));
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void publishInputNotNullNotNullOutputVoid() throws Exception {

    // Arrange
    final Bus objectUnderTest = new Bus();
    final HashMap hashMap = new HashMap();
    Reflector.setField(objectUnderTest, "subscribers", hashMap);
    final Event event =
        (Event) Reflector.getInstance("com.kerio.im.core.api.service.ServiceBus$Event");
    final ExceptionHandler handler =
        (ExceptionHandler)
            Reflector.getInstance("com.kerio.im.core.api.service.ServiceBus$ExceptionHandler");

    // Act
    objectUnderTest.publish(event, handler);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void publishInputNotNullOutputVoid00117ad973139868e99() throws Exception {

    // Arrange
    final Bus objectUnderTest = new Bus();
    final HashMap hashMap = new HashMap();
    Reflector.setField(objectUnderTest, "subscribers", hashMap);
    final Event event =
        (Event) Reflector.getInstance("com.kerio.im.core.api.service.ServiceBus$Event");

    // Act
    objectUnderTest.publish(event);
  }
}
