package com.kerio.im.core.conversation;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;

import com.kerio.im.core.conversation.ArchiveBufferSchema.DATA;
import com.kerio.im.core.conversation.ArchiveBufferSchema.LIMITS;
import com.kerio.im.core.conversation.ArchiveBufferSchema.RECORD_TYPE;
import com.kerio.im.core.conversation.ArchiveBufferSchema.SCHEMA_NAME;
import com.kerio.im.core.conversation.ArchiveBufferSchema.SQL;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class ArchiveBufferSchemaDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: ArchiveBufferSchema */
  // Test generated by Diffblue Deeptest.

  @Test
  public void toIntOutputZero() {

    // Arrange
    final RECORD_TYPE objectUnderTest = RECORD_TYPE.message;

    // Act
    final int retval = objectUnderTest.toInt();

    // result
    assertEquals(0, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput1() {

    // Act
    final DATA[] retval = DATA.values();

    // result
    assertArrayEquals(new DATA[] {DATA.schema_version}, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput2() {

    // Act
    final RECORD_TYPE[] retval = RECORD_TYPE.values();

    // result
    assertArrayEquals(new RECORD_TYPE[] {RECORD_TYPE.message, RECORD_TYPE.file}, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput3() {

    // Act
    final LIMITS[] retval = LIMITS.values();

    // result
    assertArrayEquals(new LIMITS[] {LIMITS.JID, LIMITS.TEXT, LIMITS.FILENAME}, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput12() {

    // Act
    final SCHEMA_NAME[] retval = SCHEMA_NAME.values();

    // result
    assertArrayEquals(new SCHEMA_NAME[] {SCHEMA_NAME.archive}, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput32() {

    // Act
    final SQL[] retval = SQL.values();

    // result
    assertArrayEquals(new SQL[] {SQL.getParticipants, SQL.addParticipant, SQL.storeRecord}, retval);
  }
}
