package com.kerio.im.core.conversation;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import com.kerio.im.core.conversation.ConversationStorage.SessionStorage;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class ArchiveBufferStorageDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: ArchiveBufferStorage */
  // Test generated by Diffblue Deeptest.

  @Test
  public void latestInputNotNullNotNullOutputNotNull() throws Exception {

    // Arrange
    final ArchiveBufferStorage objectUnderTest =
        (ArchiveBufferStorage)
            Reflector.getInstance("com.kerio.im.core.conversation.ArchiveBufferStorage");
    Reflector.setField(objectUnderTest, "getParticipants", null);
    Reflector.setField(objectUnderTest, "addParticipant", null);
    Reflector.setField(objectUnderTest, "connectionFactory", null);
    Reflector.setField(objectUnderTest, "storeRecord", null);
    Reflector.setField(objectUnderTest, "connection", null);
    final String sender = "";
    final String recipient = "";

    // Act
    final SessionStorage retval = objectUnderTest.latest(sender, recipient);

    // result
    assertNotNull(retval);
    assertNotNull(Reflector.getInstanceField(retval, "this$0"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval, "this$0"), "getParticipants"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "this$0"), "addParticipant"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval, "this$0"), "connectionFactory"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "this$0"), "storeRecord"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "this$0"), "connection"));
    assertEquals("", Reflector.getInstanceField(retval, "recipient"));
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void latestInputNotNullOutputNotNull() throws Exception {

    // Arrange
    final ArchiveBufferStorage objectUnderTest =
        (ArchiveBufferStorage)
            Reflector.getInstance("com.kerio.im.core.conversation.ArchiveBufferStorage");
    Reflector.setField(objectUnderTest, "getParticipants", null);
    Reflector.setField(objectUnderTest, "addParticipant", null);
    Reflector.setField(objectUnderTest, "connectionFactory", null);
    Reflector.setField(objectUnderTest, "storeRecord", null);
    Reflector.setField(objectUnderTest, "connection", null);
    final String room = "";

    // Act
    final SessionStorage retval = objectUnderTest.latest(room);

    // result
    assertNotNull(retval);
    assertNotNull(Reflector.getInstanceField(retval, "this$0"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval, "this$0"), "getParticipants"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "this$0"), "addParticipant"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval, "this$0"), "connectionFactory"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "this$0"), "storeRecord"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "this$0"), "connection"));
    assertEquals("", Reflector.getInstanceField(retval, "recipient"));
  }
}
