package com.kerio.im.core.conversation.archive;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import java.io.File;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class FileStoreDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: FileStore */
  // Test generated by Diffblue Deeptest.
  @PrepareForTest(File.class)
  @Test
  public void getDestinationOutputNotNull() throws Exception {

    // Arrange
    final FileStore objectUnderTest =
        (FileStore) Reflector.getInstance("com.kerio.im.core.conversation.archive.FileStore");
    final FileFactory fileFactory =
        (FileFactory) Reflector.getInstance("com.kerio.im.core.conversation.archive.FileFactory");
    final File file = PowerMockito.mock(File.class);
    PowerMockito.when(file.getAbsolutePath()).thenReturn("");
    Reflector.setField(file, "prefixLength", 1);
    Reflector.setField(file, "path", "/..");
    Reflector.setField(fileFactory, "parent", file);
    Reflector.setField(objectUnderTest, "fileManager", fileFactory);
    Reflector.setField(objectUnderTest, "fileWriterFactory", null);
    final FileStoreWriter fileStoreWriter =
        (FileStoreWriter)
            Reflector.getInstance("com.kerio.im.core.conversation.archive.FileStoreWriter");
    final File file1 = PowerMockito.mock(File.class);
    Reflector.setField(file1, "prefixLength", 1);
    Reflector.setField(file1, "path", "/");
    Reflector.setField(fileStoreWriter, "file", file1);
    final FileStoreWriter.SizeCheck sizeCheck =
        (FileStoreWriter.SizeCheck)
            Reflector.getInstance(
                "com.kerio.im.core.conversation.archive.FileStoreWriter$SizeCheck");
    Reflector.setField(sizeCheck, "checkInterval", 0);
    Reflector.setField(sizeCheck, "count", 0);
    Reflector.setField(sizeCheck, "limit", 0L);
    final File file2 = PowerMockito.mock(File.class);
    Reflector.setField(file2, "prefixLength", 1);
    Reflector.setField(file2, "path", "/");
    Reflector.setField(sizeCheck, "file", file2);
    Reflector.setField(fileStoreWriter, "sizeCheck", sizeCheck);
    Reflector.setField(fileStoreWriter, "output", null);
    Reflector.setField(objectUnderTest, "fileWriter", fileStoreWriter);

    // Act
    final String retval = objectUnderTest.getDestination();

    // result
    assertEquals("", retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void openInputNotNullZeroOutputNotNull() throws Exception {

    // Arrange
    final File destination = PowerMockito.mock(File.class);
    Reflector.setField(destination, "prefixLength", 0);
    Reflector.setField(destination, "path", "");
    final long limit = 0L;

    // Act
    final FileStore retval = FileStore.open(destination, limit);

    // result
    assertNotNull(retval);
    assertNotNull(Reflector.getInstanceField(retval, "fileManager"));
    assertNotNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "fileManager"), "parent"));
    assertEquals(
        0,
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "fileManager"), "parent"),
            "prefixLength"));
    assertEquals(
        "",
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "fileManager"), "parent"),
            "path"));
    assertNotNull(Reflector.getInstanceField(retval, "fileWriterFactory"));
    assertEquals(
        new Long(0L),
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval, "fileWriterFactory"), "limit"));
    assertEquals(
        Reflector.getInstanceField(retval, "fileManager"),
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval, "fileWriterFactory"), "fileManager"));
    assertNull(Reflector.getInstanceField(retval, "fileWriter"));
  }
}
