package com.kerio.im.core.conversation.archive;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;
import static org.mockito.AdditionalMatchers.or;
import static org.mockito.Matchers.isA;
import static org.mockito.Matchers.isNull;

import com.diffblue.deeptestutils.Reflector;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;
import sun.nio.cs.StreamEncoder;

@RunWith(PowerMockRunner.class)
public class FileStoreWriterFactoryDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: FileStoreWriterFactory */
  // Test generated by Diffblue Deeptest.
  @PrepareForTest(FileStoreWriterFactory.class)
  @Test
  public void createInputNotNullOutputNotNull() throws Exception {

    // Arrange
    final FileStoreWriterFactory objectUnderTest =
        (FileStoreWriterFactory)
            Reflector.getInstance("com.kerio.im.core.conversation.archive.FileStoreWriterFactory");
    Reflector.setField(objectUnderTest, "limit", 0L);
    final FileFactory fileFactory =
        (FileFactory) Reflector.getInstance("com.kerio.im.core.conversation.archive.FileFactory");
    Reflector.setField(fileFactory, "parent", null);
    Reflector.setField(objectUnderTest, "fileManager", fileFactory);
    final File file = PowerMockito.mock(File.class);
    Reflector.setField(file, "prefixLength", 0);
    Reflector.setField(file, "path", null);
    final FileStoreWriter fileStoreWriter = PowerMockito.mock(FileStoreWriter.class);
    Reflector.setField(fileStoreWriter, "file", file);
    final FileStoreWriter.SizeCheck sizeCheck =
        (FileStoreWriter.SizeCheck)
            Reflector.getInstance(
                "com.kerio.im.core.conversation.archive.FileStoreWriter$SizeCheck");
    Reflector.setField(sizeCheck, "checkInterval", 16);
    Reflector.setField(sizeCheck, "count", 0);
    Reflector.setField(sizeCheck, "limit", 0L);
    Reflector.setField(sizeCheck, "file", file);
    Reflector.setField(fileStoreWriter, "sizeCheck", sizeCheck);
    final OutputStreamWriter outputStreamWriter =
        (OutputStreamWriter) Reflector.getInstance("java.io.OutputStreamWriter");
    final StreamEncoder streamEncoder =
        (StreamEncoder) Reflector.getInstance("sun.nio.cs.StreamEncoder");
    Reflector.setField(streamEncoder, "leftoverChar", '\u0000');
    Reflector.setField(streamEncoder, "cs", null);
    Reflector.setField(streamEncoder, "isOpen", false);
    Reflector.setField(streamEncoder, "haveLeftoverChar", false);
    Reflector.setField(streamEncoder, "lcb", null);
    Reflector.setField(streamEncoder, "ch", null);
    Reflector.setField(streamEncoder, "encoder", null);
    Reflector.setField(streamEncoder, "out", null);
    Reflector.setField(streamEncoder, "bb", null);
    final Object object = new Object();
    Reflector.setField(streamEncoder, "lock", object);
    Reflector.setField(streamEncoder, "writeBuffer", null);
    Reflector.setField(outputStreamWriter, "se", streamEncoder);
    final FileOutputStream fileOutputStream =
        (FileOutputStream) Reflector.getInstance("java.io.FileOutputStream");
    Reflector.setField(outputStreamWriter, "lock", fileOutputStream);
    Reflector.setField(outputStreamWriter, "writeBuffer", null);
    Reflector.setField(fileStoreWriter, "output", outputStreamWriter);
    PowerMockito.whenNew(FileStoreWriter.class)
        .withParameterTypes(File.class, FileStoreWriter.SizeCheck.class)
        .withArguments(
            or(isA(File.class), isNull(File.class)),
            or(isA(FileStoreWriter.SizeCheck.class), isNull(FileStoreWriter.SizeCheck.class)))
        .thenReturn(fileStoreWriter);

    // Act
    final FileStoreWriter retval = objectUnderTest.create(file);

    // result
    assertNotNull(retval);
    assertNotNull(Reflector.getInstanceField(retval, "file"));
    assertEquals(
        0, Reflector.getInstanceField(Reflector.getInstanceField(retval, "file"), "prefixLength"));
    assertNull(Reflector.getInstanceField(Reflector.getInstanceField(retval, "file"), "path"));
    assertNotNull(Reflector.getInstanceField(retval, "sizeCheck"));
    assertEquals(
        16,
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval, "sizeCheck"), "checkInterval"));
    assertEquals(
        0, Reflector.getInstanceField(Reflector.getInstanceField(retval, "sizeCheck"), "count"));
    assertEquals(
        0L, Reflector.getInstanceField(Reflector.getInstanceField(retval, "sizeCheck"), "limit"));
    assertEquals(
        Reflector.getInstanceField(retval, "file"),
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "sizeCheck"), "file"));
    assertNotNull(Reflector.getInstanceField(retval, "output"));
    assertNotNull(Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"));
    assertEquals(
        '\u0000',
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"),
            "leftoverChar"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"), "cs"));
    assertEquals(
        false,
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"),
            "isOpen"));
    assertEquals(
        false,
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"),
            "haveLeftoverChar"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"), "lcb"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"), "ch"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"),
            "encoder"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"), "out"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"), "bb"));
    assertNotNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"),
            "lock"));
    assertNull(
        Reflector.getInstanceField(
            Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "se"),
            "writeBuffer"));
    assertNotNull(Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "lock"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "output"), "writeBuffer"));
  }
}
