package com.kerio.im.core.domain;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import static org.mockito.AdditionalMatchers.or;
import static org.mockito.Matchers.isA;
import static org.mockito.Matchers.isNull;

import com.diffblue.deeptestutils.Reflector;
import com.diffblue.deeptestutils.mock.DTUMemberMatcher;
import com.kerio.im.bean.Domain;
import com.kerio.im.core.api.service.ServiceBus;
import com.kerio.im.external.ExtService;
import com.kerio.im.xmpp.api.XmppDomains;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Set;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.api.mockito.expectation.PowerMockitoStubber;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class DomainFullSyncDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: DomainFullSync */
  // Test generated by Diffblue Deeptest.

  @Test
  public void access$000InputNotNullOutputZero() throws Exception {

    // Arrange
    final Object x0 =
        Reflector.getInstance("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    Reflector.setField(x0, "skipped", 0);
    Reflector.setField(x0, "domainControl", null);
    Reflector.setField(x0, "checked", 0);
    Reflector.setField(x0, "added", 0);
    Reflector.setField(x0, "allDomains", null);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "access$000",
            Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler"));
    methodUnderTest.setAccessible(true);
    final int retval = (int) methodUnderTest.invoke(null, x0);

    // result
    assertEquals(0, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void access$100InputNotNullOutputZero() throws Exception {

    // Arrange
    final Object x0 =
        Reflector.getInstance("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    Reflector.setField(x0, "skipped", 0);
    Reflector.setField(x0, "domainControl", null);
    Reflector.setField(x0, "checked", 0);
    Reflector.setField(x0, "added", 0);
    Reflector.setField(x0, "allDomains", null);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "access$100",
            Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler"));
    methodUnderTest.setAccessible(true);
    final int retval = (int) methodUnderTest.invoke(null, x0);

    // result
    assertEquals(0, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void access$200InputNotNullOutputZero() throws Exception {

    // Arrange
    final Object x0 =
        Reflector.getInstance("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    Reflector.setField(x0, "skipped", 0);
    Reflector.setField(x0, "domainControl", null);
    Reflector.setField(x0, "checked", 0);
    Reflector.setField(x0, "added", 0);
    Reflector.setField(x0, "allDomains", null);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "access$200",
            Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler"));
    methodUnderTest.setAccessible(true);
    final int retval = (int) methodUnderTest.invoke(null, x0);

    // result
    assertEquals(0, retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {"com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler"},
      value = {XmppDomains.class, ServiceBus.class, Domain.class})
  @Test
  public void handleInputNotNullNotNullOutputVoid() throws Exception {

    // Arrange
    final Object objectUnderTest =
        Reflector.getInstance("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    Reflector.setField(objectUnderTest, "skipped", 0);
    final DomainControl domainControl =
        (DomainControl) Reflector.getInstance("com.kerio.im.core.domain.DomainControl");
    final ServiceBus serviceBus = PowerMockito.mock(ServiceBus.class);
    Reflector.setField(domainControl, "bus", serviceBus);
    final HashMap<String, Domain> hashMap = new HashMap<String, Domain>();
    Reflector.setField(domainControl, "current", hashMap);
    final Domain domain = PowerMockito.mock(Domain.class);
    Reflector.setField(domainControl, "serviceDomain", domain);
    final XmppDomains xmppDomains = PowerMockito.mock(XmppDomains.class);
    Reflector.setField(domainControl, "xmppDomains", xmppDomains);
    Reflector.setField(objectUnderTest, "domainControl", domainControl);
    Reflector.setField(objectUnderTest, "checked", 0);
    Reflector.setField(objectUnderTest, "added", 3);
    final java.util.HashSet<String> hashSet = new java.util.HashSet<String>();
    hashSet.add("jjj+=");
    Reflector.setField(objectUnderTest, "allDomains", hashSet);
    final String id = "        ";
    final String name = "HHHQMHI";
    final Domain domain1 = PowerMockito.mock(Domain.class);
    final Method getNameMethod = DTUMemberMatcher.method(Domain.class, "getName");
    ((PowerMockitoStubber) PowerMockito.doReturn("MMMMMDLM").doReturn("        ").doReturn(""))
        .when(domain1, getNameMethod)
        .withNoArguments();
    PowerMockito.whenNew(Domain.class)
        .withParameterTypes(String.class, String.class)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(String.class), isNull(String.class)))
        .thenReturn(domain1);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "handle", Reflector.forName("java.lang.String"), Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    methodUnderTest.invoke(objectUnderTest, id, name);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {"com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler"},
      value = {XmppDomains.class, ServiceBus.class, Domain.class})
  @Test
  public void handleInputNotNullNotNullOutputVoid2() throws Exception {

    // Arrange
    final Object objectUnderTest =
        Reflector.getInstance("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    Reflector.setField(objectUnderTest, "skipped", 0);
    final DomainControl domainControl =
        (DomainControl) Reflector.getInstance("com.kerio.im.core.domain.DomainControl");
    final ServiceBus serviceBus = PowerMockito.mock(ServiceBus.class);
    Reflector.setField(domainControl, "bus", serviceBus);
    final HashMap<String, Domain> hashMap = new HashMap<String, Domain>();
    Reflector.setField(domainControl, "current", hashMap);
    final Domain domain = PowerMockito.mock(Domain.class);
    final Method getNameMethod = DTUMemberMatcher.method(Domain.class, "getName");
    PowerMockito.doReturn(".........").when(domain, getNameMethod).withNoArguments();
    Reflector.setField(domainControl, "serviceDomain", domain);
    final XmppDomains xmppDomains = PowerMockito.mock(XmppDomains.class);
    Reflector.setField(domainControl, "xmppDomains", xmppDomains);
    Reflector.setField(objectUnderTest, "domainControl", domainControl);
    Reflector.setField(objectUnderTest, "checked", 0);
    Reflector.setField(objectUnderTest, "added", 4);
    final java.util.HashSet<String> hashSet = new java.util.HashSet<String>();
    hashSet.add("~~s{y");
    Reflector.setField(objectUnderTest, "allDomains", hashSet);
    final String id = "        ";
    final String name = "~~S{Y";
    final Domain domain1 = PowerMockito.mock(Domain.class);
    final Method getNameMethod1 = DTUMemberMatcher.method(Domain.class, "getName");
    ((PowerMockitoStubber)
            PowerMockito.doReturn(">")
                .doReturn(";#**Z****:")
                .doReturn("")
                .doReturn("")
                .doReturn("2222L@"))
        .when(domain1, getNameMethod1)
        .withNoArguments();
    PowerMockito.whenNew(Domain.class)
        .withParameterTypes(String.class, String.class)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(String.class), isNull(String.class)))
        .thenReturn(domain1);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "handle", Reflector.forName("java.lang.String"), Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    methodUnderTest.invoke(objectUnderTest, id, name);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void notFoundOutputNull() throws Exception {

    // Arrange
    final Object objectUnderTest =
        Reflector.getInstance("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    Reflector.setField(objectUnderTest, "skipped", 0);
    Reflector.setField(objectUnderTest, "domainControl", null);
    Reflector.setField(objectUnderTest, "checked", 0);
    Reflector.setField(objectUnderTest, "added", 0);
    Reflector.setField(objectUnderTest, "allDomains", null);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.domain.DomainFullSync$ExtDomainsHandler");
    final Method methodUnderTest = classUnderTest.getDeclaredMethod("notFound");
    methodUnderTest.setAccessible(true);
    final Set<String> retval = (Set<String>) methodUnderTest.invoke(objectUnderTest);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest({Domain.class, ExtService.class, XmppDomains.class})
  @Test
  public void syncOutputVoid2() throws Exception {

    // Arrange
    final DomainFullSync objectUnderTest =
        (DomainFullSync) Reflector.getInstance("com.kerio.im.core.domain.DomainFullSync");
    final ExtService extService = PowerMockito.mock(ExtService.class);
    Reflector.setField(objectUnderTest, "extService", extService);
    final XmppDomains xmppDomains = PowerMockito.mock(XmppDomains.class);
    final java.util.HashSet hashSet = new java.util.HashSet();
    hashSet.add(null);
    final Method allMethod = DTUMemberMatcher.method(XmppDomains.class, "all");
    PowerMockito.doReturn(hashSet).when(xmppDomains, allMethod).withNoArguments();
    Reflector.setField(objectUnderTest, "xmppDomains", xmppDomains);
    final DomainControl domainControl =
        (DomainControl) Reflector.getInstance("com.kerio.im.core.domain.DomainControl");
    Reflector.setField(domainControl, "bus", null);
    final HashMap<String, Domain> hashMap = new HashMap<String, Domain>();
    hashMap.put(null, null);
    Reflector.setField(domainControl, "current", hashMap);
    final Domain domain = PowerMockito.mock(Domain.class);
    final Method getNameMethod = DTUMemberMatcher.method(Domain.class, "getName");
    PowerMockito.doReturn(
            "\u7667\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u766e\u897e")
        .when(domain, getNameMethod)
        .withNoArguments();
    Reflector.setField(domainControl, "serviceDomain", domain);
    final XmppDomains xmppDomains1 = PowerMockito.mock(XmppDomains.class);
    Reflector.setField(domainControl, "xmppDomains", xmppDomains1);
    Reflector.setField(objectUnderTest, "domainControl", domainControl);

    // Act
    objectUnderTest.sync();
  }
}
