package com.kerio.im.core.remote;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import java.util.HashMap;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class CommandEventDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: CommandEvent */
  // Test generated by Diffblue Deeptest.

  @Test
  public void asyncOutputVoid() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    Reflector.setField(objectUnderTest, "content", null);
    Reflector.setField(objectUnderTest, "response", null);

    // Act
    objectUnderTest.async();
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void chainInputNotNull1OutputNotNull() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    Reflector.setField(objectUnderTest, "content", null);
    Reflector.setField(objectUnderTest, "response", null);
    final String type = "";
    final HashMap<String, String> content = new HashMap<String, String>();
    content.put(null, null);

    // Act
    final CommandEvent retval = objectUnderTest.chain(type, content);

    // result
    assertNotNull(retval);
    assertEquals(false, Reflector.getInstanceField(retval, "fail"));
    assertNull(retval.getResponseHandler());
    assertEquals(false, Reflector.getInstanceField(retval, "async"));
    assertNull(retval.getFailMessage());
    assertNull(retval.getId());
    assertEquals("", retval.getType());
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    hashMap.put(null, null);
    assertEquals(hashMap, Reflector.getInstanceField(retval, "content"));
    assertNull(Reflector.getInstanceField(retval, "response"));
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void containsInputNotNullOutputFalse() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    hashMap.put(null, null);
    Reflector.setField(objectUnderTest, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(objectUnderTest, "response", hashMap1);
    final String name = "";

    // Act
    final boolean retval = objectUnderTest.contains(name);

    // result
    assertEquals(false, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void containsInputNotNullOutputTrue() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    hashMap.put("", "AA");
    Reflector.setField(objectUnderTest, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(objectUnderTest, "response", hashMap1);
    final String name = "";

    // Act
    final boolean retval = objectUnderTest.contains(name);

    // result
    assertEquals(true, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void failInputNotNullOutputVoid() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    Reflector.setField(objectUnderTest, "content", null);
    Reflector.setField(objectUnderTest, "response", null);
    final String message = "";

    // Act
    objectUnderTest.fail(message);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getInputNotNullNotNullOutputNotNull() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    Reflector.setField(objectUnderTest, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(objectUnderTest, "response", hashMap1);
    final String name = "";
    final String optional = " ";

    // Act
    final String retval = objectUnderTest.get(name, optional);

    // result
    assertEquals(" ", retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getInputNotNullNotNullOutputNull() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    hashMap.put("", null);
    Reflector.setField(objectUnderTest, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(objectUnderTest, "response", hashMap1);
    final String name = "";
    final String optional = " ";

    // Act
    final String retval = objectUnderTest.get(name, optional);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getInputNotNullOutputIllegalArgumentException() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    Reflector.setField(objectUnderTest, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(objectUnderTest, "response", hashMap1);
    final String name = "!";

    // Act
    thrown.expect(IllegalArgumentException.class);
    objectUnderTest.get(name);

    // Method is not expected to return due to exception thrown
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getInputNotNullOutputNotNull() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    hashMap.put("@@@@@@@@@", "");
    Reflector.setField(objectUnderTest, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(objectUnderTest, "response", hashMap1);
    final String name = "@@@@@@@@@";

    // Act
    final String retval = objectUnderTest.get(name);

    // result
    assertEquals("", retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void interestedInputNotNullOutputFalse() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", null);
    Reflector.setField(objectUnderTest, "content", null);
    Reflector.setField(objectUnderTest, "response", null);
    final String type = "";

    // Act
    final boolean retval = objectUnderTest.interested(type);

    // result
    assertEquals(false, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void interestedInputNotNullOutputFalse2() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", "``");
    Reflector.setField(objectUnderTest, "content", null);
    Reflector.setField(objectUnderTest, "response", null);
    final String type = "";

    // Act
    final boolean retval = objectUnderTest.interested(type);

    // result
    assertEquals(false, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void interestedInputNullOutputFalse() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", null);
    Reflector.setField(objectUnderTest, "type", "");
    Reflector.setField(objectUnderTest, "content", null);
    Reflector.setField(objectUnderTest, "response", null);
    final String type = null;

    // Act
    final boolean retval = objectUnderTest.interested(type);

    // result
    assertEquals(false, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void toStringOutputNotNull() throws Exception {

    // Arrange
    final CommandEvent objectUnderTest =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(objectUnderTest, "fail", false);
    Reflector.setField(objectUnderTest, "responseHandler", null);
    Reflector.setField(objectUnderTest, "async", false);
    Reflector.setField(objectUnderTest, "failMessage", null);
    Reflector.setField(objectUnderTest, "id", "!!");
    Reflector.setField(objectUnderTest, "type", "!!!!!!!!!");
    Reflector.setField(objectUnderTest, "content", null);
    Reflector.setField(objectUnderTest, "response", null);

    // Act
    final String retval = objectUnderTest.toString();

    // result
    assertEquals("CommandEvent{type=!!!!!!!!!, id=!!, content=null}", retval);
  }
}
