package com.kerio.im.core.remote;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import static org.mockito.AdditionalMatchers.or;
import static org.mockito.Matchers.isA;
import static org.mockito.Matchers.isNull;

import com.diffblue.deeptestutils.Reflector;
import com.diffblue.deeptestutils.mock.DTUMemberMatcher;
import com.kerio.im.core.api.service.ServiceBus;
import java.lang.reflect.Method;
import java.util.HashMap;
import org.json.JSONObject;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.api.mockito.expectation.PowerMockitoStubber;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class RemoteControlDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: RemoteControl */
  // Test generated by Diffblue Deeptest.
  @PrepareForTest({JSONObject.class, RemoteControl.class})
  @Test
  public void createResponseInputNotNull0OutputNotNull() throws Exception {

    // Arrange
    final RemoteControl objectUnderTest =
        (RemoteControl) Reflector.getInstance("com.kerio.im.core.remote.RemoteControl");
    Reflector.setField(objectUnderTest, "errorHandler", null);
    final ServiceBus serviceBus =
        (ServiceBus) Reflector.getInstance("com.kerio.im.core.api.service.ServiceBus");
    Reflector.setField(objectUnderTest, "bus", serviceBus);
    final CommandEvent event =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(event, "fail", true);
    Reflector.setField(event, "responseHandler", null);
    Reflector.setField(event, "async", false);
    Reflector.setField(event, "failMessage", null);
    Reflector.setField(event, "id", null);
    Reflector.setField(event, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    hashMap.put(null, null);
    Reflector.setField(event, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(event, "response", hashMap1);
    final HashMap<String, String> content = new HashMap<String, String>();
    final JSONObject jSONObject4 = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject6 = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject5 = PowerMockito.mock(JSONObject.class);
    final Method putMethod1 =
        DTUMemberMatcher.method(JSONObject.class, "put", String.class, Object.class);
    ((PowerMockitoStubber) PowerMockito.doReturn(jSONObject5).doReturn(jSONObject6))
        .when(jSONObject4, putMethod1)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(Object.class), isNull(Object.class)));
    final JSONObject jSONObject = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject3 = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject2 = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject1 = PowerMockito.mock(JSONObject.class);
    final Method putMethod =
        DTUMemberMatcher.method(JSONObject.class, "put", String.class, Object.class);
    ((PowerMockitoStubber)
            PowerMockito.doReturn(jSONObject1).doReturn(jSONObject2).doReturn(jSONObject3))
        .when(jSONObject, putMethod)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(Object.class), isNull(Object.class)));
    final Method toStringMethod = DTUMemberMatcher.method(JSONObject.class, "toString");
    PowerMockito.doReturn("").when(jSONObject, toStringMethod).withNoArguments();
    PowerMockito.whenNew(JSONObject.class)
        .withNoArguments()
        .thenReturn(jSONObject)
        .thenReturn(jSONObject4);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.remote.RemoteControl");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "createResponse",
            Reflector.forName("com.kerio.im.core.remote.CommandEvent"),
            Reflector.forName("java.util.Map"));
    methodUnderTest.setAccessible(true);
    final String retval = (String) methodUnderTest.invoke(objectUnderTest, event, content);

    // result
    assertEquals("", retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest({JSONObject.class, RemoteControl.class})
  @Test
  public void createResponseInputNotNull0OutputNotNull2() throws Exception {

    // Arrange
    final RemoteControl objectUnderTest =
        (RemoteControl) Reflector.getInstance("com.kerio.im.core.remote.RemoteControl");
    Reflector.setField(objectUnderTest, "errorHandler", null);
    final ServiceBus serviceBus =
        (ServiceBus) Reflector.getInstance("com.kerio.im.core.api.service.ServiceBus");
    Reflector.setField(objectUnderTest, "bus", serviceBus);
    final CommandEvent event =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(event, "fail", false);
    Reflector.setField(event, "responseHandler", null);
    Reflector.setField(event, "async", false);
    Reflector.setField(event, "failMessage", null);
    Reflector.setField(event, "id", null);
    Reflector.setField(event, "type", null);
    final HashMap<String, String> hashMap = new HashMap<String, String>();
    hashMap.put(null, null);
    Reflector.setField(event, "content", hashMap);
    final HashMap<String, String> hashMap1 = new HashMap<String, String>();
    hashMap1.put(null, null);
    Reflector.setField(event, "response", hashMap1);
    final HashMap<String, String> content = new HashMap<String, String>();
    final JSONObject jSONObject4 = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject5 = PowerMockito.mock(JSONObject.class);
    final Method putMethod1 =
        DTUMemberMatcher.method(JSONObject.class, "put", String.class, Object.class);
    PowerMockito.doReturn(jSONObject5)
        .when(jSONObject4, putMethod1)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(Object.class), isNull(Object.class)));
    final JSONObject jSONObject = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject3 = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject2 = PowerMockito.mock(JSONObject.class);
    final JSONObject jSONObject1 = PowerMockito.mock(JSONObject.class);
    final Method putMethod =
        DTUMemberMatcher.method(JSONObject.class, "put", String.class, Object.class);
    ((PowerMockitoStubber)
            PowerMockito.doReturn(jSONObject1).doReturn(jSONObject2).doReturn(jSONObject3))
        .when(jSONObject, putMethod)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(Object.class), isNull(Object.class)));
    final Method toStringMethod = DTUMemberMatcher.method(JSONObject.class, "toString");
    PowerMockito.doReturn("").when(jSONObject, toStringMethod).withNoArguments();
    PowerMockito.whenNew(JSONObject.class)
        .withNoArguments()
        .thenReturn(jSONObject)
        .thenReturn(jSONObject4);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.remote.RemoteControl");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "createResponse",
            Reflector.forName("com.kerio.im.core.remote.CommandEvent"),
            Reflector.forName("java.util.Map"));
    methodUnderTest.setAccessible(true);
    final String retval = (String) methodUnderTest.invoke(objectUnderTest, event, content);

    // result
    assertEquals("", retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest({JSONObject.class, RemoteControl.class})
  @Test
  public void createResponseInputNotNull1OutputNull() throws Exception {

    // Arrange
    final RemoteControl objectUnderTest =
        (RemoteControl) Reflector.getInstance("com.kerio.im.core.remote.RemoteControl");
    Reflector.setField(objectUnderTest, "errorHandler", null);
    Reflector.setField(objectUnderTest, "bus", null);
    final CommandEvent event =
        (CommandEvent) Reflector.getInstance("com.kerio.im.core.remote.CommandEvent");
    Reflector.setField(event, "fail", false);
    Reflector.setField(event, "responseHandler", null);
    Reflector.setField(event, "async", false);
    Reflector.setField(event, "failMessage", null);
    Reflector.setField(event, "id", null);
    Reflector.setField(event, "type", null);
    Reflector.setField(event, "content", null);
    Reflector.setField(event, "response", null);
    final HashMap<String, String> content = new HashMap<String, String>();
    content.put(null, null);
    final JSONObject jSONObject1 = PowerMockito.mock(JSONObject.class);
    final Method putMethod1 =
        DTUMemberMatcher.method(JSONObject.class, "put", String.class, Object.class);
    ((PowerMockitoStubber) PowerMockito.doReturn(null).doReturn(null))
        .when(jSONObject1, putMethod1)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(Object.class), isNull(Object.class)));
    final JSONObject jSONObject = PowerMockito.mock(JSONObject.class);
    final Method putMethod =
        DTUMemberMatcher.method(JSONObject.class, "put", String.class, Object.class);
    ((PowerMockitoStubber) PowerMockito.doReturn(null).doReturn(null).doReturn(null))
        .when(jSONObject, putMethod)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(Object.class), isNull(Object.class)));
    final Method toStringMethod = DTUMemberMatcher.method(JSONObject.class, "toString");
    PowerMockito.doReturn(null).when(jSONObject, toStringMethod).withNoArguments();
    PowerMockito.whenNew(JSONObject.class)
        .withNoArguments()
        .thenReturn(jSONObject)
        .thenReturn(jSONObject1);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.remote.RemoteControl");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "createResponse",
            Reflector.forName("com.kerio.im.core.remote.CommandEvent"),
            Reflector.forName("java.util.Map"));
    methodUnderTest.setAccessible(true);
    final String retval = (String) methodUnderTest.invoke(objectUnderTest, event, content);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void isInputNotNullOutputFalse() throws Exception {

    // Arrange
    final RemoteControl.PROTOCOL objectUnderTest = RemoteControl.PROTOCOL.reason;
    final String command = "";

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.remote.RemoteControl$PROTOCOL");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("is", Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    final boolean retval = (boolean) methodUnderTest.invoke(objectUnderTest, command);

    // result
    assertEquals(false, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput2() {

    // Act
    final RemoteControl.PROTOCOL[] retval = RemoteControl.PROTOCOL.values();

    // result
    assertArrayEquals(
        new RemoteControl.PROTOCOL[] {RemoteControl.PROTOCOL.result, RemoteControl.PROTOCOL.reason},
        retval);
  }
}
