package com.kerio.im.core.service;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import com.kerio.im.bean.Port.Filter;
import com.kerio.im.core.service.EventService.ServiceAccessImpl;
import com.kerio.im.external.ExtService;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Set;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class EventServiceDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: EventService */
  // Test generated by Diffblue Deeptest.

  @Test
  public void access$100InputNotNullOutputNull() throws Exception {

    // Arrange
    final ServiceAccessImpl x0 = new ServiceAccessImpl();
    Reflector.setField(x0, "connectionLimit", null);
    Reflector.setField(x0, "serviceFilter", null);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.service.EventService$ServiceAccessImpl");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "access$100",
            Reflector.forName("com.kerio.im.core.service.EventService$ServiceAccessImpl"));
    methodUnderTest.setAccessible(true);
    final CombinedFilter retval = (CombinedFilter) methodUnderTest.invoke(null, x0);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void access$200InputNotNullOutputNull() throws Exception {

    // Arrange
    final ServiceAccessImpl x0 = new ServiceAccessImpl();
    Reflector.setField(x0, "connectionLimit", null);
    Reflector.setField(x0, "serviceFilter", null);

    // Act
    final Class<?> classUnderTest =
        Reflector.forName("com.kerio.im.core.service.EventService$ServiceAccessImpl");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "access$200",
            Reflector.forName("com.kerio.im.core.service.EventService$ServiceAccessImpl"));
    methodUnderTest.setAccessible(true);
    final ConnectionLimit retval = (ConnectionLimit) methodUnderTest.invoke(null, x0);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(ExtService.class)
  @Test
  public void allServicePortsInputNotNullNotNullFalseNotNullOutput0() throws Exception {

    // Arrange
    final EventService objectUnderTest =
        (EventService) Reflector.getInstance("com.kerio.im.core.service.EventService");
    final ServiceProcessor serviceProcessor =
        (ServiceProcessor) Reflector.getInstance("com.kerio.im.core.service.ServiceProcessor");
    Reflector.setField(serviceProcessor, "security", null);
    Reflector.setField(serviceProcessor, "status", null);
    Reflector.setField(serviceProcessor, "serviceToPort", null);
    Reflector.setField(serviceProcessor, "xmppPorts", null);
    Reflector.setField(objectUnderTest, "serviceProcessor", serviceProcessor);
    final ExtService extService = PowerMockito.mock(ExtService.class);
    Reflector.setField(objectUnderTest, "extService", extService);
    Reflector.setField(objectUnderTest, "hostname", null);
    final String serviceId = "";
    final String hostname = "";
    final boolean ssl = false;
    final ConnectionListener listener =
        (ConnectionListener) Reflector.getInstance("com.kerio.im.core.service.ConnectionListener");
    Reflector.setField(listener, "extService", null);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.service.EventService");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "allServicePorts",
            Reflector.forName("java.lang.String"),
            Reflector.forName("java.lang.String"),
            Reflector.forName("boolean"),
            Reflector.forName("com.kerio.im.core.service.ConnectionListener"));
    methodUnderTest.setAccessible(true);
    final Set<ServicePort> retval =
        (Set<ServicePort>)
            methodUnderTest.invoke(objectUnderTest, serviceId, hostname, ssl, listener);

    // result
    final java.util.HashSet<ServicePort> hashSet = new java.util.HashSet<ServicePort>();
    assertEquals(hashSet, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void filterMaskInputNotNullNotNullTrueOutputVoid() throws Exception {

    // Arrange
    final ServiceAccessImpl objectUnderTest = new ServiceAccessImpl();
    Reflector.setField(objectUnderTest, "connectionLimit", null);
    final CombinedFilter combinedFilter =
        (CombinedFilter) Reflector.getInstance("com.kerio.im.core.service.CombinedFilter");
    Reflector.setField(combinedFilter, "allEnabled", false);
    final ArrayList<Filter> arrayList = new ArrayList<Filter>();
    Reflector.setField(combinedFilter, "filterChain", arrayList);
    Reflector.setField(objectUnderTest, "serviceFilter", combinedFilter);
    final String net = "!!";
    final String mask = "0";
    final boolean enabled = true;

    // Act
    objectUnderTest.filterMask(net, mask, enabled);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void hasExceptionsOutputFalse() throws Exception {

    // Arrange
    final EventService.SecurityAccessHandlerImpl objectUnderTest =
        (EventService.SecurityAccessHandlerImpl)
            Reflector.getInstance(
                "com.kerio.im.core.service.EventService$SecurityAccessHandlerImpl");
    Reflector.setField(objectUnderTest, "tlsRequired", false);
    Reflector.setField(objectUnderTest, "exceptions", false);
    Reflector.setField(objectUnderTest, "connectionLimit", null);
    Reflector.setField(objectUnderTest, "serviceFilter", null);

    // Act
    final boolean retval = objectUnderTest.hasExceptions();

    // result
    assertEquals(false, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void limitInputPositiveOutputVoid() throws Exception {

    // Arrange
    final ServiceAccessImpl objectUnderTest = new ServiceAccessImpl();
    final ConnectionLimit connectionLimit =
        (ConnectionLimit) Reflector.getInstance("com.kerio.im.core.service.ConnectionLimit");
    Reflector.setField(connectionLimit, "current", 0L);
    Reflector.setField(connectionLimit, "maximum", 0);
    Reflector.setField(objectUnderTest, "connectionLimit", connectionLimit);
    Reflector.setField(objectUnderTest, "serviceFilter", null);
    final int count = 1;

    // Act
    objectUnderTest.limit(count);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput4() {

    // Act
    final EventService.Operation[] retval = EventService.Operation.values();

    // result
    assertArrayEquals(
        new EventService.Operation[] {
          EventService.Operation.start,
          EventService.Operation.stop,
          EventService.Operation.changed,
          EventService.Operation.security
        },
        retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput5() {

    // Act
    final EventService.Content[] retval = EventService.Content.values();

    // result
    assertArrayEquals(
        new EventService.Content[] {
          EventService.Content.identifier, EventService.Content.action,
          EventService.Content.secure, EventService.Content.tlsRequired,
          EventService.Content.tlsExceptions
        },
        retval);
  }
}
