package com.kerio.im.core.service;

import static org.junit.Assert.assertArrayEquals;
import static org.mockito.AdditionalMatchers.or;
import static org.mockito.Matchers.isA;
import static org.mockito.Matchers.isNull;

import com.diffblue.deeptestutils.Reflector;
import com.diffblue.deeptestutils.mock.DTUMemberMatcher;
import com.google.common.collect.Sets;
import java.lang.reflect.Method;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.api.mockito.expectation.PowerMockitoStubber;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class SecurityManagerDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: SecurityManager */
  // Test generated by Diffblue Deeptest.
  @PrepareForTest(Sets.class)
  @Test
  public void safeCiphersInput0Output0() throws Exception {

    // Setup mocks
    PowerMockito.mockStatic(Sets.class);

    // Arrange
    final SecurityManager objectUnderTest = new SecurityManager();
    Reflector.setField(objectUnderTest, "supportedProtocols", null);
    Reflector.setField(objectUnderTest, "supportedCiphersPerProtocol", null);
    Reflector.setField(objectUnderTest, "supportedProtocolsLock", null);
    final String[] defaultEnabledCiphers = {};
    final java.util.HashSet hashSet1 = new java.util.HashSet();
    hashSet1.add(null);
    final java.util.HashSet hashSet = new java.util.HashSet();
    hashSet.add(null);
    final Method newHashSetMethod =
        DTUMemberMatcher.method(Sets.class, "newHashSet", java.lang.Object[].class);
    ((PowerMockitoStubber) PowerMockito.doReturn(hashSet).doReturn(hashSet1))
        .when(Sets.class, newHashSetMethod)
        .withArguments(or(isA(java.lang.Object[].class), isNull(java.lang.Object[].class)));

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.service.SecurityManager");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("safeCiphers", Reflector.forName("java.lang.String[]"));
    methodUnderTest.setAccessible(true);
    final String[] retval =
        (String[]) methodUnderTest.invoke(objectUnderTest, new Object[] {defaultEnabledCiphers});

    // result
    assertArrayEquals(new String[] {}, retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(Sets.class)
  @Test
  public void unsafeCiphersInput0Output0() throws Exception {

    // Setup mocks
    PowerMockito.mockStatic(Sets.class);

    // Arrange
    final SecurityManager objectUnderTest = new SecurityManager();
    Reflector.setField(objectUnderTest, "supportedProtocols", null);
    Reflector.setField(objectUnderTest, "supportedCiphersPerProtocol", null);
    Reflector.setField(objectUnderTest, "supportedProtocolsLock", null);
    final String[] defaultEnabledCiphers = {};
    final java.util.HashSet hashSet1 = new java.util.HashSet();
    hashSet1.add(null);
    final java.util.HashSet hashSet = new java.util.HashSet();
    hashSet.add(null);
    final Method newHashSetMethod =
        DTUMemberMatcher.method(Sets.class, "newHashSet", java.lang.Object[].class);
    ((PowerMockitoStubber) PowerMockito.doReturn(hashSet).doReturn(hashSet1))
        .when(Sets.class, newHashSetMethod)
        .withArguments(or(isA(java.lang.Object[].class), isNull(java.lang.Object[].class)));

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.service.SecurityManager");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("unsafeCiphers", Reflector.forName("java.lang.String[]"));
    methodUnderTest.setAccessible(true);
    final String[] retval =
        (String[]) methodUnderTest.invoke(objectUnderTest, new Object[] {defaultEnabledCiphers});

    // result
    assertArrayEquals(new String[] {}, retval);
  }
}
