package com.kerio.im.core.service;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import com.kerio.im.bean.Port.Filter;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.LinkedList;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class ServiceManagerDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: ServiceManager */
  // Test generated by Diffblue Deeptest.

  @Test
  public void createServicePortInputZeroOutputNotNull() throws Exception {

    // Arrange
    final ServiceManager objectUnderTest =
        (ServiceManager) Reflector.getInstance("com.kerio.im.core.service.ServiceManager");
    Reflector.setField(objectUnderTest, "serviceProcessor", null);
    Reflector.setField(objectUnderTest, "hostname", null);
    final int servicePort = 0;

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.service.ServiceManager");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("createServicePort", Reflector.forName("int"));
    methodUnderTest.setAccessible(true);
    final ServicePort retval = (ServicePort) methodUnderTest.invoke(objectUnderTest, servicePort);

    // result
    assertNotNull(retval);
    assertNotNull(retval.getSecurity());
    assertNotNull(Reflector.getInstanceField(retval.getSecurity(), "filter"));
    assertEquals(
        true,
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval.getSecurity(), "filter"), "allEnabled"));
    final LinkedList<Filter> linkedList = new LinkedList<Filter>();
    assertEquals(
        linkedList,
        Reflector.getInstanceField(
            Reflector.getInstanceField(retval.getSecurity(), "filter"), "filterChain"));
    assertEquals(false, Reflector.getInstanceField(retval.getSecurity(), "requireTLS"));
    assertEquals(false, Reflector.getInstanceField(retval.getSecurity(), "hasExceptions"));
    assertEquals(false, Reflector.getInstanceField(retval, "ssl"));
    assertNotNull(Reflector.getInstanceField(retval, "limit"));
    assertEquals(
        0L, Reflector.getInstanceField(Reflector.getInstanceField(retval, "limit"), "current"));
    assertEquals(1, ((ConnectionLimit) Reflector.getInstanceField(retval, "limit")).getLimit());
    assertEquals("Instant Messaging Control", retval.getServiceName());
    assertNotNull(Reflector.getInstanceField(retval, "listener"));
    assertNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "listener"), "extService"));
    assertEquals("//control/localhost", retval.getId());
    assertEquals(0, retval.getPort());
    assertNull(retval.getHost());
    assertNotNull(Reflector.getInstanceField(retval, "filter"));
    assertEquals(
        true,
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "filter"), "allEnabled"));
    assertNotNull(
        Reflector.getInstanceField(Reflector.getInstanceField(retval, "filter"), "filterChain"));
    assertEquals(
        1,
        ((java.util.List)
                Reflector.getInstanceField(
                    Reflector.getInstanceField(retval, "filter"), "filterChain"))
            .size());
    assertNotNull(
        ((java.util.List)
                Reflector.getInstanceField(
                    Reflector.getInstanceField(retval, "filter"), "filterChain"))
            .get(0));
    assertNotNull(
        Reflector.getInstanceField(
            ((java.util.List)
                    Reflector.getInstanceField(
                        Reflector.getInstanceField(retval, "filter"), "filterChain"))
                .get(0),
            "host"));
    assertEquals("localhost", retval.getIfc());
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getServiceIdInputZeroOutputNull() throws Exception {

    // Arrange
    final ServiceManager objectUnderTest =
        (ServiceManager) Reflector.getInstance("com.kerio.im.core.service.ServiceManager");
    final ServiceProcessor serviceProcessor =
        (ServiceProcessor) Reflector.getInstance("com.kerio.im.core.service.ServiceProcessor");
    Reflector.setField(serviceProcessor, "security", null);
    Reflector.setField(serviceProcessor, "status", null);
    final HashMap hashMap = new HashMap();
    Reflector.setField(serviceProcessor, "serviceToPort", hashMap);
    Reflector.setField(serviceProcessor, "xmppPorts", null);
    Reflector.setField(objectUnderTest, "serviceProcessor", serviceProcessor);
    Reflector.setField(objectUnderTest, "hostname", null);
    final int port = 0;

    // Act
    final String retval = objectUnderTest.getServiceId(port);

    // result
    assertNull(retval);
  }
}
