package com.kerio.im.core.service;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import com.kerio.im.external.ExtService;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Set;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class ServiceProcessorDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: ServiceProcessor */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getServiceIdInputZeroOutputNull() throws Exception {

    // Arrange
    final ServiceProcessor objectUnderTest =
        (ServiceProcessor) Reflector.getInstance("com.kerio.im.core.service.ServiceProcessor");
    final Security security =
        (Security) Reflector.getInstance("com.kerio.im.core.service.Security");
    final CombinedFilter combinedFilter =
        (CombinedFilter) Reflector.getInstance("com.kerio.im.core.service.CombinedFilter");
    Reflector.setField(combinedFilter, "allEnabled", false);
    Reflector.setField(combinedFilter, "filterChain", null);
    Reflector.setField(security, "filter", combinedFilter);
    Reflector.setField(security, "requireTLS", false);
    Reflector.setField(security, "hasExceptions", false);
    Reflector.setField(objectUnderTest, "security", security);
    Reflector.setField(objectUnderTest, "status", null);
    final HashMap hashMap = new HashMap();
    Reflector.setField(objectUnderTest, "serviceToPort", hashMap);
    Reflector.setField(objectUnderTest, "xmppPorts", null);
    final int port = 0;

    // Act
    final String retval = objectUnderTest.getServiceId(port);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void portsInputNotNullOutputNull() throws Exception {

    // Arrange
    final ServiceProcessor objectUnderTest =
        (ServiceProcessor) Reflector.getInstance("com.kerio.im.core.service.ServiceProcessor");
    Reflector.setField(objectUnderTest, "security", null);
    Reflector.setField(objectUnderTest, "status", null);
    final HashMap hashMap = new HashMap();
    hashMap.put("", null);
    Reflector.setField(objectUnderTest, "serviceToPort", hashMap);
    Reflector.setField(objectUnderTest, "xmppPorts", null);
    final String serviceId = "";

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.service.ServiceProcessor");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("ports", Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    final Set<ServicePort> retval =
        (Set<ServicePort>) methodUnderTest.invoke(objectUnderTest, serviceId);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(ExtService.class)
  @Test
  public void setExtServiceInputNotNullOutputVoid() throws Exception {

    // Arrange
    final ServiceProcessor objectUnderTest =
        (ServiceProcessor) Reflector.getInstance("com.kerio.im.core.service.ServiceProcessor");
    final Security security =
        (Security) Reflector.getInstance("com.kerio.im.core.service.Security");
    Reflector.setField(security, "filter", null);
    Reflector.setField(security, "requireTLS", false);
    Reflector.setField(security, "hasExceptions", false);
    Reflector.setField(objectUnderTest, "security", security);
    Reflector.setField(objectUnderTest, "status", null);
    Reflector.setField(objectUnderTest, "serviceToPort", null);
    Reflector.setField(objectUnderTest, "xmppPorts", null);
    final ExtService extService = PowerMockito.mock(ExtService.class);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.service.ServiceProcessor");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "setExtService", Reflector.forName("com.kerio.im.external.ExtService"));
    methodUnderTest.setAccessible(true);
    methodUnderTest.invoke(objectUnderTest, extService);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void statusInputNotNullOutputNotNull() throws Exception {

    // Arrange
    final ServiceProcessor objectUnderTest =
        (ServiceProcessor) Reflector.getInstance("com.kerio.im.core.service.ServiceProcessor");
    final Security security =
        (Security) Reflector.getInstance("com.kerio.im.core.service.Security");
    final CombinedFilter combinedFilter =
        (CombinedFilter) Reflector.getInstance("com.kerio.im.core.service.CombinedFilter");
    Reflector.setField(combinedFilter, "allEnabled", false);
    Reflector.setField(combinedFilter, "filterChain", null);
    Reflector.setField(security, "filter", combinedFilter);
    Reflector.setField(security, "requireTLS", false);
    Reflector.setField(security, "hasExceptions", false);
    Reflector.setField(objectUnderTest, "security", security);
    final HashMap<String, ServiceProcessor.Status> hashMap =
        new HashMap<String, ServiceProcessor.Status>();
    hashMap.put(null, null);
    Reflector.setField(objectUnderTest, "status", hashMap);
    Reflector.setField(objectUnderTest, "serviceToPort", null);
    Reflector.setField(objectUnderTest, "xmppPorts", null);
    final String serviceId = "";

    // Act
    final ServiceProcessor.Status retval = objectUnderTest.status(serviceId);

    // result
    assertEquals(ServiceProcessor.Status.Unknown, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void statusInputNotNullOutputNotNull2() throws Exception {

    // Arrange
    final ServiceProcessor objectUnderTest =
        (ServiceProcessor) Reflector.getInstance("com.kerio.im.core.service.ServiceProcessor");
    final Security security =
        (Security) Reflector.getInstance("com.kerio.im.core.service.Security");
    final CombinedFilter combinedFilter =
        (CombinedFilter) Reflector.getInstance("com.kerio.im.core.service.CombinedFilter");
    Reflector.setField(combinedFilter, "allEnabled", false);
    Reflector.setField(combinedFilter, "filterChain", null);
    Reflector.setField(security, "filter", combinedFilter);
    Reflector.setField(security, "requireTLS", false);
    Reflector.setField(security, "hasExceptions", false);
    Reflector.setField(objectUnderTest, "security", security);
    final HashMap<String, ServiceProcessor.Status> hashMap =
        new HashMap<String, ServiceProcessor.Status>();
    hashMap.put("#\"", ServiceProcessor.Status.Stopped);
    Reflector.setField(objectUnderTest, "status", hashMap);
    Reflector.setField(objectUnderTest, "serviceToPort", null);
    Reflector.setField(objectUnderTest, "xmppPorts", null);
    final String serviceId = "#\"";

    // Act
    final ServiceProcessor.Status retval = objectUnderTest.status(serviceId);

    // result
    assertEquals(ServiceProcessor.Status.Stopped, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void valuesOutput4() {

    // Act
    final ServiceProcessor.Status[] retval = ServiceProcessor.Status.values();

    // result
    assertArrayEquals(
        new ServiceProcessor.Status[] {
          ServiceProcessor.Status.Running,
          ServiceProcessor.Status.Stopped,
          ServiceProcessor.Status.Error,
          ServiceProcessor.Status.Unknown
        },
        retval);
  }
}
