package com.kerio.im.core.user;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import static org.mockito.AdditionalMatchers.or;
import static org.mockito.Matchers.anyBoolean;
import static org.mockito.Matchers.isA;
import static org.mockito.Matchers.isNull;

import com.diffblue.deeptestutils.Reflector;
import com.diffblue.deeptestutils.mock.DTUMemberMatcher;
import com.kerio.im.bean.Domain;
import com.kerio.im.bean.User;
import com.kerio.im.external.ExtService;
import java.lang.reflect.Method;
import java.util.Collection;
import java.util.HashMap;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.api.mockito.expectation.PowerMockitoStubber;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class UserCacheDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: UserCache */
  // Test generated by Diffblue Deeptest.

  @Test
  public void allInputNotNullOutput1() throws Exception {

    // Arrange
    final UserCache objectUnderTest =
        (UserCache) Reflector.getInstance("com.kerio.im.core.user.UserCache");
    final HashMap<String, User> hashMap = new HashMap<String, User>();
    hashMap.put(null, null);
    Reflector.setField(objectUnderTest, "users", hashMap);
    Reflector.setField(objectUnderTest, "domain", null);
    Reflector.setField(objectUnderTest, "extService", null);
    final User except = (User) Reflector.getInstance("com.kerio.im.bean.User");

    // Act
    final Collection<User> retval = objectUnderTest.all(except);

    // result
    final java.util.HashSet<User> hashSet = new java.util.HashSet<User>();
    hashSet.add(null);
    assertEquals(hashSet, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void allOutput1() throws Exception {

    // Arrange
    final UserCache objectUnderTest =
        (UserCache) Reflector.getInstance("com.kerio.im.core.user.UserCache");
    final HashMap<String, User> hashMap = new HashMap<String, User>();
    hashMap.put(null, null);
    Reflector.setField(objectUnderTest, "users", hashMap);
    Reflector.setField(objectUnderTest, "domain", null);
    Reflector.setField(objectUnderTest, "extService", null);

    // Act
    final Collection<User> retval = objectUnderTest.all();

    // result
    final java.util.HashSet<User> hashSet = new java.util.HashSet<User>();
    hashSet.add(null);
    assertEquals(hashSet, retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void findInputNotNullOutputNull() throws Exception {

    // Arrange
    final UserCache objectUnderTest =
        (UserCache) Reflector.getInstance("com.kerio.im.core.user.UserCache");
    final HashMap<String, User> hashMap = new HashMap<String, User>();
    hashMap.put("", null);
    Reflector.setField(objectUnderTest, "users", hashMap);
    Reflector.setField(objectUnderTest, "domain", null);
    Reflector.setField(objectUnderTest, "extService", null);
    final String userName = "";

    // Act
    final User retval = objectUnderTest.find(userName);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(fullyQualifiedNames = {"com.kerio.im.core.user.UserCache$ExternalUser"})
  @Test
  public void handleInputNotNullNotNullFalseFalseFalseOutputVoid() throws Exception {

    // Arrange
    final UserCache.ExternalUser objectUnderTest =
        (UserCache.ExternalUser)
            Reflector.getInstance("com.kerio.im.core.user.UserCache$ExternalUser");
    final HashMap<String, User> hashMap = new HashMap<String, User>();
    Reflector.setField(objectUnderTest, "users", hashMap);
    Reflector.setField(objectUnderTest, "domain", null);
    final String login = "";
    final String fullname = "        ";
    final boolean enabled = false;
    final boolean inGal = false;
    final boolean domainRestriction = false;
    final User user = PowerMockito.mock(User.class);
    PowerMockito.whenNew(User.class)
        .withParameterTypes(
            String.class, String.class, String.class, boolean.class, boolean.class, boolean.class)
        .withArguments(
            or(isA(String.class), isNull(String.class)),
            or(isA(String.class), isNull(String.class)),
            or(isA(String.class), isNull(String.class)),
            anyBoolean(),
            anyBoolean(),
            anyBoolean())
        .thenReturn(user);

    // Act
    objectUnderTest.handle(login, fullname, enabled, inGal, domainRestriction);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest({ExtService.class, Domain.class})
  @Test
  public void refreshOutputVoid() throws Exception {

    // Arrange
    final UserCache objectUnderTest =
        (UserCache) Reflector.getInstance("com.kerio.im.core.user.UserCache");
    final HashMap<String, User> hashMap = new HashMap<String, User>();
    hashMap.put(null, null);
    Reflector.setField(objectUnderTest, "users", hashMap);
    final Domain domain = PowerMockito.mock(Domain.class);
    final Method getNameMethod = DTUMemberMatcher.method(Domain.class, "getName");
    ((PowerMockitoStubber)
            PowerMockito.doReturn("        ").doReturn("        ").doReturn("        "))
        .when(domain, getNameMethod)
        .withNoArguments();
    final Method getIdMethod = DTUMemberMatcher.method(Domain.class, "getId");
    PowerMockito.doReturn("        ").when(domain, getIdMethod).withNoArguments();
    Reflector.setField(objectUnderTest, "domain", domain);
    final ExtService extService = PowerMockito.mock(ExtService.class);
    Reflector.setField(objectUnderTest, "extService", extService);

    // Act
    objectUnderTest.refresh();
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(User.class)
  @Test
  public void removeInputNotNullOutputVoid() throws Exception {

    // Arrange
    final UserCache objectUnderTest =
        (UserCache) Reflector.getInstance("com.kerio.im.core.user.UserCache");
    final HashMap<String, User> hashMap = new HashMap<String, User>();
    hashMap.put("", null);
    Reflector.setField(objectUnderTest, "users", hashMap);
    final Domain domain = (Domain) Reflector.getInstance("com.kerio.im.bean.Domain");
    Reflector.setField(objectUnderTest, "domain", domain);
    Reflector.setField(objectUnderTest, "extService", null);
    final User user = PowerMockito.mock(User.class);
    final Method getLoginMethod = DTUMemberMatcher.method(User.class, "getLogin");
    PowerMockito.doReturn("").when(user, getLoginMethod).withNoArguments();

    // Act
    objectUnderTest.remove(user);
  }
}
