package com.kerio.im.core.user;

import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import com.diffblue.deeptestutils.mock.DTUMemberMatcher;
import com.kerio.im.bean.Domain;
import com.kerio.im.xmpp.api.XmppUsers;
import java.lang.reflect.Method;
import java.util.HashMap;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.api.mockito.expectation.PowerMockitoStubber;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class UserControlListDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: UserControlList */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getInputNotNullOutputNull() throws Exception {

    // Arrange
    final UserControlList objectUnderTest =
        (UserControlList) Reflector.getInstance("com.kerio.im.core.user.UserControlList");
    final HashMap<String, UserControl> hashMap = new HashMap<String, UserControl>();
    hashMap.put("\"\"\"\"\"\"\"\"\"", null);
    Reflector.setField(objectUnderTest, "userControlMap", hashMap);
    Reflector.setField(objectUnderTest, "xmppService", null);
    Reflector.setField(objectUnderTest, "extService", null);
    final String domain = "#########\"";

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.core.user.UserControlList");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod("get", Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    final UserControl retval = (UserControl) methodUnderTest.invoke(objectUnderTest, domain);

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest({XmppUsers.class, Domain.class})
  @Test
  public void removeInputNotNullOutputVoid3() throws Exception {

    // Arrange
    final UserControlList objectUnderTest =
        (UserControlList) Reflector.getInstance("com.kerio.im.core.user.UserControlList");
    final HashMap<String, UserControl> hashMap = new HashMap<String, UserControl>();
    final UserControl userControl =
        (UserControl) Reflector.getInstance("com.kerio.im.core.user.UserControl");
    Reflector.setField(userControl, "userCache", null);
    Reflector.setField(userControl, "domain", null);
    final XmppUsers xmppUsers = PowerMockito.mock(XmppUsers.class);
    Reflector.setField(userControl, "xmppUsers", xmppUsers);
    Reflector.setField(userControl, "groups", null);
    hashMap.put("", userControl);
    Reflector.setField(objectUnderTest, "userControlMap", hashMap);
    Reflector.setField(objectUnderTest, "xmppService", null);
    Reflector.setField(objectUnderTest, "extService", null);
    final Domain domain = PowerMockito.mock(Domain.class);
    final Method getNameMethod = DTUMemberMatcher.method(Domain.class, "getName");
    ((PowerMockitoStubber)
            PowerMockito.doReturn("        ").doReturn("").doReturn("").doReturn(" "))
        .when(domain, getNameMethod)
        .withNoArguments();

    // Act
    objectUnderTest.remove(domain);
  }
}
