/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.core.service;

import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;

/**
 *
 * @author tskoda
 */
public final class FilterTestUtil {
    
    private FilterTestUtil() {}
    
    
    public static InetAddress ip(int b1, int b2, int b3, int b4) throws UnknownHostException {
        return InetAddress.getByAddress(new byte[]{(byte) b1, (byte) b2, (byte) b3, (byte) b4});
    }
    
    public static InetAddress ip(long b) throws UnknownHostException {
        return InetAddress.getByAddress(ByteBuffer.allocate(2 * Long.BYTES).putLong(b).putLong(0).array());
    }
    
    public static InetAddress ip(String s) throws UnknownHostException {
        return InetAddress.getByName(s);
    }
    
    public static Inet6Address ip6(String s) throws UnknownHostException {
        return (Inet6Address)InetAddress.getByName(s);
    }
    
//    public static InetAddress ip(String s1, String s2, String s3, String s4) {
//        
//    }
    
}
 