/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.kerio.im.external;

/**
 *
 * @author vbystricky
 */
public class IMContactID {

    private final String userName;
    private final String domain;

    public IMContactID(String id) throws IllegalArgumentException {
        String[] parts = id.split("@");
        if (parts == null || parts.length != 2) {
            throw new IllegalArgumentException("Invalid contact id " + id);
        }
        userName = parts[0];
        domain = parts[1];
    }

    public IMContactID(String userName, String domain) {
        this.userName = userName;
        this.domain = domain;
    }

    public String getUserName() {
        return userName;
    }

    public String getDomain() {
        return domain;
    }

    public String getFullName() {
        return userName + "@" + domain;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null || !(o instanceof IMContactID)) {
            return false;
        }
        IMContactID contact = (IMContactID) o;
        return contact.getUserName().equalsIgnoreCase(userName) && contact.getDomain().equalsIgnoreCase(domain);
    }

    @Override
    public String toString() {
        return getFullName();
    }
}
