/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.external;

/**
 *
 * @author vbystricky
 */
public class IMEvent<T> {

    private final T event;
    private final IMContactID recipient;

    public IMEvent(T event, IMContactID recipient) {
        if (event == null || recipient == null) {
            throw new IllegalArgumentException("IMEvent null argument.");
        }
        this.event = event;
        this.recipient = recipient;
    }

    public T getEvent() {
        return event;
    }

    public IMContactID getRecipient() {
        return recipient;
    }
}
