/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.external;

import com.fasterxml.jackson.annotation.JsonProperty;

/**
 *
 * @author vbystricky
 */
public class IMMessage {

    public enum MessageEvent {
        active,
        inactive
    }
    @JsonProperty(value = "messageId")
    Integer messageId;
    @JsonProperty(value = "text")
    String text;
    @JsonProperty(value = "event")
    MessageEvent event;
    @JsonProperty(value = "to")
    Integer to;
    @JsonProperty(value = "from")
    IMContactID from;
    @JsonProperty(value = "time")
    String time;

    public IMMessage() {
    }

    public IMMessage(Integer messageId, String text, MessageEvent event, Integer to, IMContactID from, String time) {
        this.messageId = messageId;
        this.text = text;
        this.event = event;
        this.to = to;
        this.from = from;
        this.time = time;
    }

    public Integer getMessageId() {
        return messageId;
    }

    public void setMessageId(Integer messageId) {
        this.messageId = messageId;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public MessageEvent getEvent() {
        return event;
    }

    public void setEvent(MessageEvent event) {
        this.event = event;
    }

    public Integer getTo() {
        return to;
    }

    public void setTo(Integer to) {
        this.to = to;
    }

    public IMContactID getFrom() {
        return from;
    }

    public void setFrom(IMContactID from) {
        this.from = from;
    }

    public String getTime() {
        return time;
    }

    public void setTime(String time) {
        this.time = time;
    }

}
