/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.im;

import com.kerio.im.external.IMContactID;
import com.kerio.im.external.IMConversation;
import com.kerio.im.external.IMMessage;
import com.kerio.im.external.IMPresence;
import com.kerio.im.external.ImResponseEnvelope;
import com.kerio.im.external.UserImClient;

import java.util.List;

/**
 *
 * @author oleopold
 */
public class UserImClientImpl implements UserImClient {

    private final ImApi imApi;

    UserImClientImpl(ImApi imApi) {
        this.imApi = imApi;
    }

    @Override
    public void setPresence(IMPresence.Status status, String text) {
        imApi.setPresence(status, text);
    }

    @Override
    public ImResponseEnvelope<List<IMConversation>> subscribeConversations(Integer requestId) {
        return imApi.subscribeConversations(requestId);
    }

    @Override
    public ImResponseEnvelope<List<IMMessage>> subscribeMessages(Integer conversationId, Integer currentMessageId, Integer requestId) {
        return imApi.subscribeMessages(conversationId, currentMessageId, requestId);
    }

    @Override
    public Integer sendMessage(IMMessage message, Boolean markAsRead) {
        return imApi.sendMessage(message, markAsRead);
    }

    @Override
    public IMConversation createConversation(List<IMContactID> contacts) {
        return imApi.createConversation(contacts);
    }

    @Override
    public int generateRequestId() {
        return imApi.generateRequestId();
    }

    @Override
    public void readConversation(Integer conversationId, Integer msgIdRead) {
        imApi.readConversation(conversationId, msgIdRead);
    }
}
