package com.kerio.im.connect;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.mockito.AdditionalMatchers.or;
import static org.mockito.Matchers.isA;
import static org.mockito.Matchers.isNull;

import com.diffblue.deeptestutils.Reflector;
import com.diffblue.deeptestutils.mock.DTUMemberMatcher;
import com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups;
import com.kerio.lib.json.api.connect.admin.struct.common.IpAddressEntry;
import com.kerio.lib.json.api.connect.admin.struct.common.IpAddressGroup;
import com.kerio.lib.json.api.connect.admin.struct.common.SearchQuery;
import com.kerio.lib.json.api.connect.admin.struct.common.SubCondition;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.api.mockito.expectation.PowerMockitoStubber;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;

@RunWith(PowerMockRunner.class)
public class AddressFilterDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: AddressFilter */
  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {
        "com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups$GetGroupListResult"
      },
      value = {IpAddressGroups.class, SearchQuery.class, AddressFilter.class})
  @Test
  public void createInputNotNullOutputNotNull() throws Exception {

    // Arrange
    final IpAddressGroups ipAddressGroupsApi = PowerMockito.mock(IpAddressGroups.class);
    final IpAddressGroups.GetGroupListResult getGroupListResult =
        PowerMockito.mock(IpAddressGroups.GetGroupListResult.class);
    final IpAddressGroup[] ipAddressGroupArray = {};
    final Method getGroupsMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetGroupListResult.class, "getGroups");
    PowerMockito.doReturn(ipAddressGroupArray)
        .when(getGroupListResult, getGroupsMethod)
        .withNoArguments();
    final Method getGroupListMethod =
        DTUMemberMatcher.method(IpAddressGroups.class, "getGroupList");
    PowerMockito.doReturn(getGroupListResult)
        .when(ipAddressGroupsApi, getGroupListMethod)
        .withNoArguments();
    final SearchQuery searchQuery = PowerMockito.mock(SearchQuery.class);
    PowerMockito.whenNew(SearchQuery.class).withNoArguments().thenReturn(searchQuery);

    // Act
    final AddressFilter retval = AddressFilter.create(ipAddressGroupsApi);

    // result
    assertNotNull(retval);
    final HashMap hashMap = new HashMap();
    assertEquals(hashMap, retval.ipAddressEntries);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {
        "com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups$GetGroupListResult"
      },
      value = {IpAddressGroups.class, SearchQuery.class, AddressFilter.class})
  @Test
  public void readAllGroupsInputNotNullOutput0() throws Exception {

    // Arrange
    final IpAddressGroups ipAddressGroupsApi = PowerMockito.mock(IpAddressGroups.class);
    final IpAddressGroups.GetGroupListResult getGroupListResult =
        PowerMockito.mock(IpAddressGroups.GetGroupListResult.class);
    final IpAddressGroup[] ipAddressGroupArray = {};
    final Method getGroupsMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetGroupListResult.class, "getGroups");
    PowerMockito.doReturn(ipAddressGroupArray)
        .when(getGroupListResult, getGroupsMethod)
        .withNoArguments();
    final Method getGroupListMethod =
        DTUMemberMatcher.method(IpAddressGroups.class, "getGroupList");
    PowerMockito.doReturn(getGroupListResult)
        .when(ipAddressGroupsApi, getGroupListMethod)
        .withNoArguments();
    final SearchQuery searchQuery = PowerMockito.mock(SearchQuery.class);
    PowerMockito.whenNew(SearchQuery.class).withNoArguments().thenReturn(searchQuery);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.connect.AddressFilter");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "readAllGroups",
            Reflector.forName("com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups"));
    methodUnderTest.setAccessible(true);
    final Map retval = (Map) methodUnderTest.invoke(null, ipAddressGroupsApi);

    // result
    final HashMap hashMap = new HashMap();
    assertEquals(hashMap, retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {
        "com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups$GetResult",
        "com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups$GetGroupListResult"
      },
      value = {
        AddressFilter.class,
        SearchQuery.class,
        SubCondition.class,
        IpAddressGroups.class,
        IpAddressGroup.class
      })
  @Test
  public void readAllGroupsInputNotNullOutput1() throws Exception {

    // Arrange
    final IpAddressGroups ipAddressGroupsApi = PowerMockito.mock(IpAddressGroups.class);
    final IpAddressGroups.GetGroupListResult getGroupListResult =
        PowerMockito.mock(IpAddressGroups.GetGroupListResult.class);
    final IpAddressGroup ipAddressGroup = PowerMockito.mock(IpAddressGroup.class);
    final Method getIdMethod = DTUMemberMatcher.method(IpAddressGroup.class, "getId");
    ((PowerMockitoStubber) PowerMockito.doReturn(null).doReturn(null))
        .when(ipAddressGroup, getIdMethod)
        .withNoArguments();
    final IpAddressGroup[] ipAddressGroupArray = {ipAddressGroup};
    final Method getGroupsMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetGroupListResult.class, "getGroups");
    PowerMockito.doReturn(ipAddressGroupArray)
        .when(getGroupListResult, getGroupsMethod)
        .withNoArguments();
    final Method getGroupListMethod =
        DTUMemberMatcher.method(IpAddressGroups.class, "getGroupList");
    PowerMockito.doReturn(getGroupListResult)
        .when(ipAddressGroupsApi, getGroupListMethod)
        .withNoArguments();
    final IpAddressGroups.GetResult getResult = PowerMockito.mock(IpAddressGroups.GetResult.class);
    final Method getTotalItemsMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetResult.class, "getTotalItems");
    PowerMockito.doReturn(null).when(getResult, getTotalItemsMethod).withNoArguments();
    final Method getMethod =
        DTUMemberMatcher.method(IpAddressGroups.class, "get", SearchQuery.class);
    PowerMockito.doReturn(getResult)
        .when(ipAddressGroupsApi, getMethod)
        .withArguments(or(isA(SearchQuery.class), isNull(SearchQuery.class)));
    final SubCondition subCondition = PowerMockito.mock(SubCondition.class);
    PowerMockito.whenNew(SubCondition.class).withNoArguments().thenReturn(subCondition);
    final SearchQuery searchQuery1 = PowerMockito.mock(SearchQuery.class);
    final SearchQuery searchQuery = PowerMockito.mock(SearchQuery.class);
    PowerMockito.whenNew(SearchQuery.class)
        .withNoArguments()
        .thenReturn(searchQuery)
        .thenReturn(searchQuery1);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.connect.AddressFilter");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "readAllGroups",
            Reflector.forName("com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups"));
    methodUnderTest.setAccessible(true);
    final Map retval = (Map) methodUnderTest.invoke(null, ipAddressGroupsApi);

    // result
    final HashMap hashMap = new HashMap();
    final LinkedList linkedList = new LinkedList();
    hashMap.put(null, linkedList);
    assertEquals(hashMap, retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {
        "com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups$GetResult"
      },
      value = {IpAddressGroups.class, SearchQuery.class, SubCondition.class, AddressFilter.class})
  @Test
  public void readGroupInputNotNullNotNullOutput0() throws Exception {

    // Arrange
    final IpAddressGroups ipAddressGroupsApi = PowerMockito.mock(IpAddressGroups.class);
    final IpAddressGroups.GetResult getResult = PowerMockito.mock(IpAddressGroups.GetResult.class);
    final Method getTotalItemsMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetResult.class, "getTotalItems");
    ((PowerMockitoStubber) PowerMockito.doReturn(0).doReturn(1))
        .when(getResult, getTotalItemsMethod)
        .withNoArguments();
    final IpAddressEntry[] ipAddressEntryArray = {};
    final Method getListMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetResult.class, "getList");
    PowerMockito.doReturn(ipAddressEntryArray).when(getResult, getListMethod).withNoArguments();
    final Method getMethod =
        DTUMemberMatcher.method(IpAddressGroups.class, "get", SearchQuery.class);
    PowerMockito.doReturn(getResult)
        .when(ipAddressGroupsApi, getMethod)
        .withArguments(or(isA(SearchQuery.class), isNull(SearchQuery.class)));
    final String groupId = "";
    final SubCondition subCondition = PowerMockito.mock(SubCondition.class);
    PowerMockito.whenNew(SubCondition.class).withNoArguments().thenReturn(subCondition);
    final SearchQuery searchQuery = PowerMockito.mock(SearchQuery.class);
    PowerMockito.whenNew(SearchQuery.class).withNoArguments().thenReturn(searchQuery);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.connect.AddressFilter");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "readGroup",
            Reflector.forName("com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups"),
            Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    final List<IpAddressEntry> retval =
        (List<IpAddressEntry>) methodUnderTest.invoke(null, ipAddressGroupsApi, groupId);

    // result
    final ArrayList<IpAddressEntry> arrayList = new ArrayList<IpAddressEntry>();
    assertEquals(arrayList, retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {
        "com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups$GetResult"
      },
      value = {IpAddressGroups.class, SearchQuery.class, SubCondition.class, AddressFilter.class})
  @Test
  public void readGroupInputNotNullNotNullOutput02() throws Exception {

    // Arrange
    final IpAddressGroups ipAddressGroupsApi = PowerMockito.mock(IpAddressGroups.class);
    final IpAddressGroups.GetResult getResult = PowerMockito.mock(IpAddressGroups.GetResult.class);
    final Method getTotalItemsMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetResult.class, "getTotalItems");
    ((PowerMockitoStubber) PowerMockito.doReturn(0).doReturn(0))
        .when(getResult, getTotalItemsMethod)
        .withNoArguments();
    final Method getMethod =
        DTUMemberMatcher.method(IpAddressGroups.class, "get", SearchQuery.class);
    PowerMockito.doReturn(getResult)
        .when(ipAddressGroupsApi, getMethod)
        .withArguments(or(isA(SearchQuery.class), isNull(SearchQuery.class)));
    final String groupId = "";
    final SubCondition subCondition = PowerMockito.mock(SubCondition.class);
    PowerMockito.whenNew(SubCondition.class).withNoArguments().thenReturn(subCondition);
    final SearchQuery searchQuery = PowerMockito.mock(SearchQuery.class);
    PowerMockito.whenNew(SearchQuery.class).withNoArguments().thenReturn(searchQuery);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.connect.AddressFilter");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "readGroup",
            Reflector.forName("com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups"),
            Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    final List<IpAddressEntry> retval =
        (List<IpAddressEntry>) methodUnderTest.invoke(null, ipAddressGroupsApi, groupId);

    // result
    final LinkedList<IpAddressEntry> linkedList = new LinkedList<IpAddressEntry>();
    assertEquals(linkedList, retval);
  }

  // Test generated by Diffblue Deeptest.
  @PrepareForTest(
      fullyQualifiedNames = {
        "com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups$GetResult"
      },
      value = {IpAddressGroups.class, SearchQuery.class, SubCondition.class, AddressFilter.class})
  @Test
  public void readGroupInputNotNullNullOutput0() throws Exception {

    // Arrange
    final IpAddressGroups ipAddressGroupsApi = PowerMockito.mock(IpAddressGroups.class);
    final IpAddressGroups.GetResult getResult = PowerMockito.mock(IpAddressGroups.GetResult.class);
    final Method getTotalItemsMethod =
        DTUMemberMatcher.method(IpAddressGroups.GetResult.class, "getTotalItems");
    PowerMockito.doReturn(null).when(getResult, getTotalItemsMethod).withNoArguments();
    final Method getMethod =
        DTUMemberMatcher.method(IpAddressGroups.class, "get", SearchQuery.class);
    PowerMockito.doReturn(getResult)
        .when(ipAddressGroupsApi, getMethod)
        .withArguments(or(isA(SearchQuery.class), isNull(SearchQuery.class)));
    final String groupId = null;
    final SubCondition subCondition = PowerMockito.mock(SubCondition.class);
    PowerMockito.whenNew(SubCondition.class).withNoArguments().thenReturn(subCondition);
    final SearchQuery searchQuery = PowerMockito.mock(SearchQuery.class);
    PowerMockito.whenNew(SearchQuery.class).withNoArguments().thenReturn(searchQuery);

    // Act
    final Class<?> classUnderTest = Reflector.forName("com.kerio.im.connect.AddressFilter");
    final Method methodUnderTest =
        classUnderTest.getDeclaredMethod(
            "readGroup",
            Reflector.forName("com.kerio.lib.json.api.connect.admin.iface.common.IpAddressGroups"),
            Reflector.forName("java.lang.String"));
    methodUnderTest.setAccessible(true);
    final List<IpAddressEntry> retval =
        (List<IpAddressEntry>) methodUnderTest.invoke(null, ipAddressGroupsApi, groupId);

    // result
    final LinkedList<IpAddressEntry> linkedList = new LinkedList<IpAddressEntry>();
    assertEquals(linkedList, retval);
  }
}
