package com.kerio.lib.json.api.connect.admin.iface;

import static org.junit.Assert.assertNull;

import com.kerio.lib.json.api.connect.admin.iface.Domains.CreateResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.GeneratePasswordResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.GetDkimDnsRecordResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.GetDomainFooterPlaceholdersResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.GetResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.GetSettingsResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.GetUserCountInfoResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.RemoveResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.RenameResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.SaveFooterImageResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.SaveWebMailLogoResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.SetResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.TestDkimDnsStatusResult;
import com.kerio.lib.json.api.connect.admin.iface.Domains.TestDomainControllerResult;
import com.kerio.lib.json.api.connect.admin.struct.ClusterError;
import com.kerio.lib.json.api.connect.admin.struct.Domain;
import com.kerio.lib.json.api.connect.admin.struct.DomainSetting;
import com.kerio.lib.json.api.connect.admin.struct.NamedConstant;
import com.kerio.lib.json.api.connect.admin.struct.UserDomainCountInfo;
import com.kerio.lib.json.api.connect.admin.struct.common.Error;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class Domains_CreateResultDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: Domains_CreateResult */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getCountInfoOutputNull() {

    // Arrange
    final GetUserCountInfoResult objectUnderTest = new GetUserCountInfoResult();

    // Act
    final UserDomainCountInfo retval = objectUnderTest.getCountInfo();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getDetailOutputNull() {

    // Arrange
    final GetDkimDnsRecordResult objectUnderTest = new GetDkimDnsRecordResult();

    // Act
    final String retval = objectUnderTest.getDetail();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorOutputNull() {

    // Arrange
    final RenameResult objectUnderTest = new RenameResult();

    // Act
    final ClusterError retval = objectUnderTest.getError();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorsOutputNull() {

    // Arrange
    final CreateResult objectUnderTest = new CreateResult();

    // Act
    final Error[] retval = objectUnderTest.getErrors();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorsOutputNull2() {

    // Arrange
    final RemoveResult objectUnderTest = new RemoveResult();

    // Act
    final Error[] retval = objectUnderTest.getErrors();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorsOutputNull3() {

    // Arrange
    final SetResult objectUnderTest = new SetResult();

    // Act
    final Error[] retval = objectUnderTest.getErrors();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorsOutputNull4() {

    // Arrange
    final TestDkimDnsStatusResult objectUnderTest = new TestDkimDnsStatusResult();

    // Act
    final Error[] retval = objectUnderTest.getErrors();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorsOutputNull5() {

    // Arrange
    final TestDomainControllerResult objectUnderTest = new TestDomainControllerResult();

    // Act
    final Error[] retval = objectUnderTest.getErrors();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getImgUrlOutputNull() {

    // Arrange
    final SaveFooterImageResult objectUnderTest = new SaveFooterImageResult();

    // Act
    final String retval = objectUnderTest.getImgUrl();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getListOutputNull() {

    // Arrange
    final GetResult objectUnderTest = new GetResult();

    // Act
    final Domain[] retval = objectUnderTest.getList();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getLogoUrlOutputNull() {

    // Arrange
    final SaveWebMailLogoResult objectUnderTest = new SaveWebMailLogoResult();

    // Act
    final String retval = objectUnderTest.getLogoUrl();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getPasswordOutputNull() {

    // Arrange
    final GeneratePasswordResult objectUnderTest = new GeneratePasswordResult();

    // Act
    final String retval = objectUnderTest.getPassword();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getPlaceholdersOutputNull() {

    // Arrange
    final GetDomainFooterPlaceholdersResult objectUnderTest =
        new GetDomainFooterPlaceholdersResult();

    // Act
    final NamedConstant[] retval = objectUnderTest.getPlaceholders();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getResultOutputNull() {

    // Arrange
    final CreateResult objectUnderTest = new CreateResult();

    // Act
    final com.kerio.lib.json.api.connect.admin.struct.common.CreateResult[] retval =
        objectUnderTest.getResult();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getSettingOutputNull() {

    // Arrange
    final GetSettingsResult objectUnderTest = new GetSettingsResult();

    // Act
    final DomainSetting retval = objectUnderTest.getSetting();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getTotalItemsOutputNull() {

    // Arrange
    final GetResult objectUnderTest = new GetResult();

    // Act
    final Integer retval = objectUnderTest.getTotalItems();

    // result
    assertNull(retval);
  }
}
