package com.kerio.lib.json.api.connect.admin.iface;

import static org.junit.Assert.assertNull;

import com.kerio.lib.json.api.connect.admin.iface.Server.CreatePathResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.FindEntityByEmailResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GenerateSupportInfoResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetAboutInfoResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetAlertListResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetBrowserLanguagesResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetClientStatisticsResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetColumnListResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetConnectionsResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetDirsResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetDownloadProgressResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetEncryptionStatusResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetLicenseExtensionsListResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetNamedConstantListResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetOpenedFoldersInfoResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetProductInfoResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetRemoteAdministrationResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetServerHashResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetServerIpAddressesResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetServerTimeResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetVersionResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.GetWebSessionsResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.IsBritishPreferredResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.PathExistsResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.StartDecryptionResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.StartEncryptionResult;
import com.kerio.lib.json.api.connect.admin.iface.Server.StartResizingResult;
import com.kerio.lib.json.api.connect.admin.struct.AboutInfo;
import com.kerio.lib.json.api.connect.admin.struct.Administration;
import com.kerio.lib.json.api.connect.admin.struct.Alert;
import com.kerio.lib.json.api.connect.admin.struct.Connection;
import com.kerio.lib.json.api.connect.admin.struct.Directory;
import com.kerio.lib.json.api.connect.admin.struct.DirectoryAccessResult;
import com.kerio.lib.json.api.connect.admin.struct.EncryptionError;
import com.kerio.lib.json.api.connect.admin.struct.EncryptionProgress;
import com.kerio.lib.json.api.connect.admin.struct.EntityDuplicate;
import com.kerio.lib.json.api.connect.admin.struct.FolderInfo;
import com.kerio.lib.json.api.connect.admin.struct.NamedConstant;
import com.kerio.lib.json.api.connect.admin.struct.ProductInfo;
import com.kerio.lib.json.api.connect.admin.struct.ServerTimeInfo;
import com.kerio.lib.json.api.connect.admin.struct.WebSession;
import com.kerio.lib.json.api.connect.admin.struct.common.Download;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class Server_CreatePathResultDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: Server_CreatePathResult */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getAboutInformationOutputNull() {

    // Arrange
    final GetAboutInfoResult objectUnderTest = new GetAboutInfoResult();

    // Act
    final AboutInfo retval = objectUnderTest.getAboutInformation();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getActionOutputNull() {

    // Arrange
    final GetEncryptionStatusResult objectUnderTest = new GetEncryptionStatusResult();

    // Act
    final String retval = objectUnderTest.getAction();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getActionOutputNull2() {

    // Arrange
    final StartDecryptionResult objectUnderTest = new StartDecryptionResult();

    // Act
    final String retval = objectUnderTest.getAction();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getActionOutputNull3() {

    // Arrange
    final StartEncryptionResult objectUnderTest = new StartEncryptionResult();

    // Act
    final String retval = objectUnderTest.getAction();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getActionOutputNull4() {

    // Arrange
    final StartResizingResult objectUnderTest = new StartResizingResult();

    // Act
    final String retval = objectUnderTest.getAction();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getAddressesOutputNull() {

    // Arrange
    final GetServerIpAddressesResult objectUnderTest = new GetServerIpAddressesResult();

    // Act
    final String[] retval = objectUnderTest.getAddresses();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getAlertsOutputNull() {

    // Arrange
    final GetAlertListResult objectUnderTest = new GetAlertListResult();

    // Act
    final Alert[] retval = objectUnderTest.getAlerts();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getBuildOutputNull() {

    // Arrange
    final GetVersionResult objectUnderTest = new GetVersionResult();

    // Act
    final Integer retval = objectUnderTest.getBuild();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getCalculatedLanguageOutputNull() {

    // Arrange
    final GetBrowserLanguagesResult objectUnderTest = new GetBrowserLanguagesResult();

    // Act
    final String[] retval = objectUnderTest.getCalculatedLanguage();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getColumnsOutputNull() {

    // Arrange
    final GetColumnListResult objectUnderTest = new GetColumnListResult();

    // Act
    final String[] retval = objectUnderTest.getColumns();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getConstantsOutputNull() {

    // Arrange
    final GetNamedConstantListResult objectUnderTest = new GetNamedConstantListResult();

    // Act
    final NamedConstant[] retval = objectUnderTest.getConstants();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getDirListOutputNull() {

    // Arrange
    final GetDirsResult objectUnderTest = new GetDirsResult();

    // Act
    final Directory[] retval = objectUnderTest.getDirList();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getEntitiesOutputNull() {

    // Arrange
    final FindEntityByEmailResult objectUnderTest = new FindEntityByEmailResult();

    // Act
    final EntityDuplicate[] retval = objectUnderTest.getEntities();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorOutputNull() {

    // Arrange
    final GetEncryptionStatusResult objectUnderTest = new GetEncryptionStatusResult();

    // Act
    final EncryptionError retval = objectUnderTest.getError();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorOutputNull2() {

    // Arrange
    final StartDecryptionResult objectUnderTest = new StartDecryptionResult();

    // Act
    final EncryptionError retval = objectUnderTest.getError();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorOutputNull3() {

    // Arrange
    final StartEncryptionResult objectUnderTest = new StartEncryptionResult();

    // Act
    final EncryptionError retval = objectUnderTest.getError();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getErrorOutputNull4() {

    // Arrange
    final StartResizingResult objectUnderTest = new StartResizingResult();

    // Act
    final EncryptionError retval = objectUnderTest.getError();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getExtensionsOutputNull() {

    // Arrange
    final GetLicenseExtensionsListResult objectUnderTest = new GetLicenseExtensionsListResult();

    // Act
    final String[] retval = objectUnderTest.getExtensions();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getFileDownloadOutputNull() {

    // Arrange
    final GenerateSupportInfoResult objectUnderTest = new GenerateSupportInfoResult();

    // Act
    final Download retval = objectUnderTest.getFileDownload();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getInfoOutputNull() {

    // Arrange
    final GetProductInfoResult objectUnderTest = new GetProductInfoResult();

    // Act
    final ProductInfo retval = objectUnderTest.getInfo();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getInfoOutputNull2() {

    // Arrange
    final GetServerTimeResult objectUnderTest = new GetServerTimeResult();

    // Act
    final ServerTimeInfo retval = objectUnderTest.getInfo();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getIsEnabledOutputNull() {

    // Arrange
    final GetClientStatisticsResult objectUnderTest = new GetClientStatisticsResult();

    // Act
    final Boolean retval = objectUnderTest.getIsEnabled();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getListOutputNull() {

    // Arrange
    final GetConnectionsResult objectUnderTest = new GetConnectionsResult();

    // Act
    final Connection[] retval = objectUnderTest.getList();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getListOutputNull2() {

    // Arrange
    final GetOpenedFoldersInfoResult objectUnderTest = new GetOpenedFoldersInfoResult();

    // Act
    final FolderInfo[] retval = objectUnderTest.getList();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getListOutputNull3() {

    // Arrange
    final GetWebSessionsResult objectUnderTest = new GetWebSessionsResult();

    // Act
    final WebSession[] retval = objectUnderTest.getList();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getMajorOutputNull() {

    // Arrange
    final GetVersionResult objectUnderTest = new GetVersionResult();

    // Act
    final Integer retval = objectUnderTest.getMajor();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getMinorOutputNull() {

    // Arrange
    final GetVersionResult objectUnderTest = new GetVersionResult();

    // Act
    final Integer retval = objectUnderTest.getMinor();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getPreferredOutputNull() {

    // Arrange
    final IsBritishPreferredResult objectUnderTest = new IsBritishPreferredResult();

    // Act
    final Boolean retval = objectUnderTest.getPreferred();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getProductOutputNull() {

    // Arrange
    final GetVersionResult objectUnderTest = new GetVersionResult();

    // Act
    final String retval = objectUnderTest.getProduct();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getProgressOutputNull() {

    // Arrange
    final GetDownloadProgressResult objectUnderTest = new GetDownloadProgressResult();

    // Act
    final Integer retval = objectUnderTest.getProgress();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getProgressOutputNull2() {

    // Arrange
    final GetEncryptionStatusResult objectUnderTest = new GetEncryptionStatusResult();

    // Act
    final EncryptionProgress retval = objectUnderTest.getProgress();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getProgressOutputNull3() {

    // Arrange
    final StartDecryptionResult objectUnderTest = new StartDecryptionResult();

    // Act
    final EncryptionProgress retval = objectUnderTest.getProgress();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getProgressOutputNull4() {

    // Arrange
    final StartEncryptionResult objectUnderTest = new StartEncryptionResult();

    // Act
    final EncryptionProgress retval = objectUnderTest.getProgress();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getProgressOutputNull5() {

    // Arrange
    final StartResizingResult objectUnderTest = new StartResizingResult();

    // Act
    final EncryptionProgress retval = objectUnderTest.getProgress();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getResultOutputNull() {

    // Arrange
    final CreatePathResult objectUnderTest = new CreatePathResult();

    // Act
    final DirectoryAccessResult retval = objectUnderTest.getResult();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getResultOutputNull2() {

    // Arrange
    final PathExistsResult objectUnderTest = new PathExistsResult();

    // Act
    final DirectoryAccessResult retval = objectUnderTest.getResult();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getRevisionOutputNull() {

    // Arrange
    final GetVersionResult objectUnderTest = new GetVersionResult();

    // Act
    final Integer retval = objectUnderTest.getRevision();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getServerHashOutputNull() {

    // Arrange
    final GetServerHashResult objectUnderTest = new GetServerHashResult();

    // Act
    final String retval = objectUnderTest.getServerHash();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getSettingOutputNull() {

    // Arrange
    final GetRemoteAdministrationResult objectUnderTest = new GetRemoteAdministrationResult();

    // Act
    final Administration retval = objectUnderTest.getSetting();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getStatusOutputNull() {

    // Arrange
    final GetEncryptionStatusResult objectUnderTest = new GetEncryptionStatusResult();

    // Act
    final String retval = objectUnderTest.getStatus();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getStatusOutputNull2() {

    // Arrange
    final StartDecryptionResult objectUnderTest = new StartDecryptionResult();

    // Act
    final String retval = objectUnderTest.getStatus();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getStatusOutputNull3() {

    // Arrange
    final StartEncryptionResult objectUnderTest = new StartEncryptionResult();

    // Act
    final String retval = objectUnderTest.getStatus();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getStatusOutputNull4() {

    // Arrange
    final StartResizingResult objectUnderTest = new StartResizingResult();

    // Act
    final String retval = objectUnderTest.getStatus();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getTotalItemsOutputNull() {

    // Arrange
    final GetConnectionsResult objectUnderTest = new GetConnectionsResult();

    // Act
    final Integer retval = objectUnderTest.getTotalItems();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getTotalItemsOutputNull2() {

    // Arrange
    final GetOpenedFoldersInfoResult objectUnderTest = new GetOpenedFoldersInfoResult();

    // Act
    final Integer retval = objectUnderTest.getTotalItems();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getTotalItemsOutputNull3() {

    // Arrange
    final GetWebSessionsResult objectUnderTest = new GetWebSessionsResult();

    // Act
    final Integer retval = objectUnderTest.getTotalItems();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getVersionOutputNull() {

    // Arrange
    final GetVersionResult objectUnderTest = new GetVersionResult();

    // Act
    final String retval = objectUnderTest.getVersion();

    // result
    assertNull(retval);
  }
}
