package com.kerio.lib.json.api.connect.admin.struct;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import com.kerio.lib.json.api.connect.admin.struct.common.ByteUnits;
import com.kerio.lib.json.api.connect.admin.struct.common.ByteValueWithUnits;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class BackupStatusDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: BackupStatus */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getBackupInProgressOutputNull() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();
    objectUnderTest.setPercents(null);
    objectUnderTest.setRemainingTime(null);
    final BackupInfo backupInfo = new BackupInfo();
    backupInfo.setIsCreated(false);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(0);
    backupInfo.setSize(byteValueWithUnits);
    objectUnderTest.setLastFull(backupInfo);
    final BackupInfo backupInfo1 = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setValue(null);
    backupInfo1.setSize(byteValueWithUnits1);
    objectUnderTest.setLastMirror(backupInfo1);
    final BackupInfo backupInfo2 = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits2 = new ByteValueWithUnits();
    byteValueWithUnits2.setValue(null);
    backupInfo2.setSize(byteValueWithUnits2);
    objectUnderTest.setLastDifferential(backupInfo2);
    objectUnderTest.setElapsedTime(null);
    objectUnderTest.setBackupInProgress(null);
    objectUnderTest.setLastBackupStatus(null);

    // Act
    final Boolean retval = objectUnderTest.getBackupInProgress();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getElapsedTimeOutputNull() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();
    objectUnderTest.setPercents(null);
    objectUnderTest.setRemainingTime(null);
    final BackupInfo backupInfo = new BackupInfo();
    backupInfo.setIsCreated(false);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(null);
    byteValueWithUnits.setValue(0);
    backupInfo.setSize(byteValueWithUnits);
    objectUnderTest.setLastFull(backupInfo);
    final BackupInfo backupInfo1 = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setValue(null);
    backupInfo1.setSize(byteValueWithUnits1);
    objectUnderTest.setLastMirror(backupInfo1);
    final BackupInfo backupInfo2 = new BackupInfo();
    objectUnderTest.setLastDifferential(backupInfo2);
    objectUnderTest.setElapsedTime(null);
    objectUnderTest.setBackupInProgress(null);
    objectUnderTest.setLastBackupStatus(null);

    // Act
    final Distance retval = objectUnderTest.getElapsedTime();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getLastBackupStatusOutputNull() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();
    objectUnderTest.setPercents(null);
    objectUnderTest.setRemainingTime(null);
    final BackupInfo backupInfo = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(null);
    backupInfo.setSize(byteValueWithUnits);
    objectUnderTest.setLastFull(backupInfo);
    final BackupInfo backupInfo1 = new BackupInfo();
    objectUnderTest.setLastMirror(backupInfo1);
    final BackupInfo backupInfo2 = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    backupInfo2.setSize(byteValueWithUnits1);
    backupInfo2.setIsCreated(false);
    objectUnderTest.setLastDifferential(backupInfo2);
    objectUnderTest.setElapsedTime(null);
    objectUnderTest.setBackupInProgress(null);
    objectUnderTest.setLastBackupStatus(null);

    // Act
    final LastBackupStatus retval = objectUnderTest.getLastBackupStatus();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getLastDifferentialOutputNull() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();

    // Act
    final BackupInfo retval = objectUnderTest.getLastDifferential();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getLastFullOutputNull() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();
    final BackupInfo backupInfo = new BackupInfo();
    backupInfo.setIsCreated(false);
    objectUnderTest.setLastDifferential(backupInfo);

    // Act
    final BackupInfo retval = objectUnderTest.getLastFull();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getLastMirrorOutputNull() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();
    final BackupInfo backupInfo = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(null);
    byteValueWithUnits.getValue();
    backupInfo.setSize(byteValueWithUnits);
    backupInfo.setIsCreated(false);
    objectUnderTest.setLastDifferential(backupInfo);
    objectUnderTest.setBackupInProgress(false);

    // Act
    final BackupInfo retval = objectUnderTest.getLastMirror();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getPercentsOutputZero() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();
    objectUnderTest.setPercents(0);
    objectUnderTest.setRemainingTime(null);
    final BackupInfo backupInfo = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(null);
    backupInfo.setSize(byteValueWithUnits);
    objectUnderTest.setLastFull(backupInfo);
    final BackupInfo backupInfo1 = new BackupInfo();
    backupInfo1.setIsCreated(false);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    backupInfo1.setSize(byteValueWithUnits1);
    objectUnderTest.setLastMirror(backupInfo1);
    final BackupInfo backupInfo2 = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits2 = new ByteValueWithUnits();
    byteValueWithUnits2.setUnits(ByteUnits.MegaBytes);
    byteValueWithUnits2.setValue(null);
    backupInfo2.setSize(byteValueWithUnits2);
    backupInfo2.setIsCreated(false);
    backupInfo2.setCreated(null);
    objectUnderTest.setLastDifferential(backupInfo2);
    objectUnderTest.setElapsedTime(null);
    objectUnderTest.setBackupInProgress(null);
    objectUnderTest.setLastBackupStatus(null);

    // Act
    final Integer retval = objectUnderTest.getPercents();

    // result
    assertEquals(new Integer(0), retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getRemainingTimeOutputNull() {

    // Arrange
    final BackupStatus objectUnderTest = new BackupStatus();
    objectUnderTest.setPercents(null);
    objectUnderTest.setRemainingTime(null);
    final BackupInfo backupInfo = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(0);
    backupInfo.setSize(byteValueWithUnits);
    objectUnderTest.setLastFull(backupInfo);
    final BackupInfo backupInfo1 = new BackupInfo();
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setValue(null);
    backupInfo1.setSize(byteValueWithUnits1);
    objectUnderTest.setLastMirror(backupInfo1);
    final BackupInfo backupInfo2 = new BackupInfo();
    objectUnderTest.setLastDifferential(backupInfo2);
    objectUnderTest.setElapsedTime(null);
    objectUnderTest.setBackupInProgress(null);
    objectUnderTest.setLastBackupStatus(null);

    // Act
    final Distance retval = objectUnderTest.getRemainingTime();

    // result
    assertNull(retval);
  }
}
