package com.kerio.lib.json.api.connect.admin.struct;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import com.kerio.lib.json.api.connect.admin.struct.common.ByteValueWithUnits;
import com.kerio.lib.json.api.connect.admin.struct.common.SizeLimit;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class DomainQuotaDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: DomainQuota */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getBlocksOutputNull() {

    // Arrange
    final DomainQuota objectUnderTest = new DomainQuota();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setEmail(null);
    objectUnderTest.setBlocks(null);
    objectUnderTest.setNotification(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setValue(0);
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);
    objectUnderTest.setWarningLimit(0);

    // Act
    final Boolean retval = objectUnderTest.getBlocks();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getConsumedSizeOutputNotNull() {

    // Arrange
    final DomainQuota objectUnderTest = new DomainQuota();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setEmail(null);
    objectUnderTest.setBlocks(null);
    objectUnderTest.setNotification(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);
    objectUnderTest.setWarningLimit(0);

    // Act
    final ByteValueWithUnits retval = objectUnderTest.getConsumedSize();

    // result
    assertNotNull(retval);
    assertNull(retval.getUnits());
    assertNull(retval.getValue());
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getDiskSizeLimitOutputNotNull() {

    // Arrange
    final DomainQuota objectUnderTest = new DomainQuota();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setEmail("");
    objectUnderTest.setBlocks(false);
    objectUnderTest.setNotification(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);
    objectUnderTest.setWarningLimit(0);

    // Act
    final SizeLimit retval = objectUnderTest.getDiskSizeLimit();

    // result
    assertNotNull(retval);
    assertNotNull(retval.getLimit());
    assertNull(retval.getLimit().getUnits());
    assertNull(retval.getLimit().getValue());
    assertEquals(new Boolean(false), retval.getIsActive());
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getEmailOutputNull() {

    // Arrange
    final DomainQuota objectUnderTest = new DomainQuota();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setEmail(null);
    objectUnderTest.setBlocks(null);
    objectUnderTest.setNotification(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);
    objectUnderTest.setWarningLimit(0);

    // Act
    final String retval = objectUnderTest.getEmail();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getNotificationOutputNull() {

    // Arrange
    final DomainQuota objectUnderTest = new DomainQuota();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits);
    objectUnderTest.setDiskSizeLimit(sizeLimit);
    objectUnderTest.setWarningLimit(0);

    // Act
    final QuotaNotification retval = objectUnderTest.getNotification();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getWarningLimitOutputZero() {

    // Arrange
    final DomainQuota objectUnderTest = new DomainQuota();
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setEmail(null);
    objectUnderTest.setBlocks(null);
    objectUnderTest.setNotification(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);
    objectUnderTest.setWarningLimit(0);

    // Act
    final Integer retval = objectUnderTest.getWarningLimit();

    // result
    assertEquals(new Integer(0), retval);
  }
}
