package com.kerio.lib.json.api.connect.admin.struct;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import com.kerio.lib.json.api.connect.admin.struct.common.ByteUnits;
import com.kerio.lib.json.api.connect.admin.struct.common.ByteValueWithUnits;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class StoreDirectoryOptionsDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: StoreDirectoryOptions */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getArchivePathOutputNull() {

    // Arrange
    final StoreDirectoryOptions objectUnderTest = new StoreDirectoryOptions();
    objectUnderTest.setArchivePath(null);
    objectUnderTest.setBackupPath(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setWatchdogHardLimit(byteValueWithUnits);
    objectUnderTest.setStorePath(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setUnits(ByteUnits.TeraBytes);
    byteValueWithUnits1.setValue(null);
    objectUnderTest.setWatchdogSoftLimit(byteValueWithUnits1);

    // Act
    final String retval = objectUnderTest.getArchivePath();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getBackupPathOutputNull() {

    // Arrange
    final StoreDirectoryOptions objectUnderTest = new StoreDirectoryOptions();
    objectUnderTest.setArchivePath("");
    objectUnderTest.setBackupPath(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setWatchdogHardLimit(byteValueWithUnits);
    objectUnderTest.setStorePath(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    objectUnderTest.setWatchdogSoftLimit(byteValueWithUnits1);

    // Act
    final String retval = objectUnderTest.getBackupPath();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getStorePathOutputNull() {

    // Arrange
    final StoreDirectoryOptions objectUnderTest = new StoreDirectoryOptions();
    objectUnderTest.setArchivePath("");
    objectUnderTest.setBackupPath(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setWatchdogHardLimit(byteValueWithUnits);
    objectUnderTest.setStorePath(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setUnits(ByteUnits.TeraBytes);
    byteValueWithUnits1.setValue(null);
    objectUnderTest.setWatchdogSoftLimit(byteValueWithUnits1);

    // Act
    final String retval = objectUnderTest.getStorePath();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getWatchdogHardLimitOutputNull() {

    // Arrange
    final StoreDirectoryOptions objectUnderTest = new StoreDirectoryOptions();
    objectUnderTest.setArchivePath(null);
    objectUnderTest.setBackupPath(null);
    objectUnderTest.setWatchdogHardLimit(null);
    objectUnderTest.setStorePath(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.TeraBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setWatchdogSoftLimit(byteValueWithUnits);

    // Act
    final ByteValueWithUnits retval = objectUnderTest.getWatchdogHardLimit();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getWatchdogSoftLimitOutputNotNull() {

    // Arrange
    final StoreDirectoryOptions objectUnderTest = new StoreDirectoryOptions();
    objectUnderTest.setArchivePath(null);
    objectUnderTest.setBackupPath(null);
    objectUnderTest.setWatchdogHardLimit(null);
    objectUnderTest.setStorePath(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.TeraBytes);
    byteValueWithUnits.setValue(null);
    objectUnderTest.setWatchdogSoftLimit(byteValueWithUnits);

    // Act
    final ByteValueWithUnits retval = objectUnderTest.getWatchdogSoftLimit();

    // result
    assertNotNull(retval);
    assertEquals(ByteUnits.TeraBytes, retval.getUnits());
    assertNull(retval.getValue());
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void toStringOutputNotNull() {

    // Arrange
    final StoreDirectoryOptions objectUnderTest = new StoreDirectoryOptions();
    objectUnderTest.setArchivePath("BBBBBB");
    objectUnderTest.setBackupPath("DDDDDD");
    objectUnderTest.setWatchdogHardLimit(null);
    objectUnderTest.setStorePath("!!!!!!!!");
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.TeraBytes);
    byteValueWithUnits.setValue(12);
    objectUnderTest.setWatchdogSoftLimit(byteValueWithUnits);

    // Act
    final String retval = objectUnderTest.toString();

    // result
    assertEquals(
        "StoreDirectoryOptions [storePath=!!!!!!!!, archivePath=BBBBBB, backupPath=DDDDDD, watchdogSoftLimit=ByteValueWithUnits [value=12, units=TeraBytes], watchdogHardLimit=null]",
        retval);
  }
}
