package com.kerio.lib.json.api.connect.admin.struct;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import com.kerio.lib.json.api.connect.admin.struct.common.ByteUnits;
import com.kerio.lib.json.api.connect.admin.struct.common.ByteValueWithUnits;
import com.kerio.lib.json.api.connect.admin.struct.common.IdEntity;
import com.kerio.lib.json.api.connect.admin.struct.common.OptionalEntity;
import com.kerio.lib.json.api.connect.admin.struct.common.SizeLimit;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class UserDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: User */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getAccessPolicyOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId("");
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(false);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight = new UserRight();
    userRight.setArchiveFolderRight(false);
    userRight.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName("");
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final SizeLimit sizeLimit = new SizeLimit(false, null);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final IdEntity retval = objectUnderTest.getAccessPolicy();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getAllowPasswordChangeOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    userRight.setUserRole(UserRoleType.AccountAdmin);
    userRight.setArchiveFolderRight(null);
    userRight.setPublicFolderRight(false);
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    final UserRight userRight1 = new UserRight();
    objectUnderTest.setGroupRole(userRight1);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final Boolean retval = objectUnderTest.getAllowPasswordChange();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getAuthTypeOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    final SizeLimit sizeLimit = new SizeLimit();
    objectUnderTest.setOutMessageLimit(sizeLimit);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(false);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    final ItemCountLimit itemCountLimit = new ItemCountLimit();
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName("");
    final EmailForwarding emailForwarding = new EmailForwarding();
    emailForwarding.setEmailAddresses(null);
    emailForwarding.setMode(UserForwardMode.UForwardNone);
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final UserAuthType retval = objectUnderTest.getAuthType();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getCleanOutItemsOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    userRight.setArchiveFolderRight(false);
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    final SizeLimit sizeLimit = new SizeLimit();
    objectUnderTest.setOutMessageLimit(sizeLimit);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(0);
    objectUnderTest.setItemSource(null);
    final UserRight userRight1 = new UserRight();
    userRight1.setUserRole(UserRoleType.AccountAdmin);
    userRight1.setArchiveFolderRight(null);
    userRight1.setPublicFolderRight(null);
    objectUnderTest.setGroupRole(userRight1);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName("");
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final CleanOut retval = objectUnderTest.getCleanOutItems();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getCompanyContactIdOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    final UserRight userRight1 = new UserRight();
    objectUnderTest.setGroupRole(userRight1);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final String retval = objectUnderTest.getCompanyContactId();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getConsumedItemsOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    final EmailForwarding emailForwarding = new EmailForwarding();
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final Integer retval = objectUnderTest.getConsumedItems();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getConsumedSizeOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    final SizeLimit sizeLimit = new SizeLimit();
    objectUnderTest.setOutMessageLimit(sizeLimit);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(0);
    objectUnderTest.setItemSource(null);
    final UserRight userRight = new UserRight();
    objectUnderTest.setGroupRole(userRight);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName("");
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final ByteValueWithUnits retval = objectUnderTest.getConsumedSize();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getDescriptionOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(false);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final String retval = objectUnderTest.getDescription();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getDiskSizeLimitOutputNotNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(null);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(false);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName("");
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final SizeLimit sizeLimit = new SizeLimit();
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setValue(0);
    sizeLimit.setLimit(byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final SizeLimit retval = objectUnderTest.getDiskSizeLimit();

    // result
    assertNotNull(retval);
    assertNotNull(retval.getLimit());
    assertNull(retval.getLimit().getUnits());
    assertEquals(new Integer(0), retval.getLimit().getValue());
    assertNull(retval.getIsActive());
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getDomainIdOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    userRight.setUserRole(UserRoleType.AccountAdmin);
    userRight.setArchiveFolderRight(null);
    userRight.setPublicFolderRight(false);
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    final UserRight userRight1 = new UserRight();
    objectUnderTest.setGroupRole(userRight1);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final String retval = objectUnderTest.getDomainId();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getEffectiveRoleOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(null);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setOutMessageLimit(sizeLimit);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(false);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName("");
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits2 = new ByteValueWithUnits();
    final SizeLimit sizeLimit1 = new SizeLimit(false, byteValueWithUnits2);
    objectUnderTest.setDiskSizeLimit(sizeLimit1);

    // Act
    final UserRight retval = objectUnderTest.getEffectiveRole();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getEmailAddressesOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final String[] retval = objectUnderTest.getEmailAddresses();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getEmailForwardingOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId("");
    objectUnderTest.setPassword(null);
    final UserRight userRight = new UserRight();
    userRight.setArchiveFolderRight(false);
    objectUnderTest.setRole(userRight);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName("");
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final EmailForwarding retval = objectUnderTest.getEmailForwarding();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getFullNameOutputNotNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    final UserRight userRight1 = new UserRight();
    objectUnderTest.setGroupRole(userRight1);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final String retval = objectUnderTest.getFullName();

    // result
    assertEquals("", retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getGroupRoleOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(0);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(false);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName("");
    final EmailForwarding emailForwarding = new EmailForwarding();
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final SizeLimit sizeLimit = new SizeLimit();
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setValue(0);
    sizeLimit.setLimit(byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final UserRight retval = objectUnderTest.getGroupRole();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getHasDefaultSpamRuleOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final Boolean retval = objectUnderTest.getHasDefaultSpamRule();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getHasDomainRestrictionOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(0);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    final EmailForwarding emailForwarding = new EmailForwarding();
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final Boolean retval = objectUnderTest.getHasDomainRestriction();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getHomeServerOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId("");
    objectUnderTest.setPassword(null);
    final UserRight userRight1 = new UserRight();
    userRight1.setArchiveFolderRight(false);
    objectUnderTest.setRole(userRight1);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final HomeServer retval = objectUnderTest.getHomeServer();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getIdOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(0);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    final String[] stringArray = {};
    objectUnderTest.setEmailAddresses(stringArray);
    final UserGroup[] userGroupArray = {};
    objectUnderTest.setUserGroups(userGroupArray);
    objectUnderTest.setIsWritableByMe(false);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName("");
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final SizeLimit sizeLimit = new SizeLimit();
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    byteValueWithUnits1.setValue(0);
    sizeLimit.setLimit(byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final String retval = objectUnderTest.getId();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getIsEnabledOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final Boolean retval = objectUnderTest.getIsEnabled();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getIsPasswordReversibleOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(false);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final Boolean retval = objectUnderTest.getIsPasswordReversible();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getIsWritableByMeOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(0);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    final EmailForwarding emailForwarding = new EmailForwarding();
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(false, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final Boolean retval = objectUnderTest.getIsWritableByMe();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getItemLimitOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId("");
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(false);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    userRight.setArchiveFolderRight(false);
    objectUnderTest.setGroupRole(userRight);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final ItemCountLimit retval = objectUnderTest.getItemLimit();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getItemSourceOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    final SizeLimit sizeLimit = new SizeLimit();
    objectUnderTest.setOutMessageLimit(sizeLimit);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(false);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    final ItemCountLimit itemCountLimit = new ItemCountLimit();
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName("");
    final EmailForwarding emailForwarding = new EmailForwarding();
    emailForwarding.setEmailAddresses(null);
    emailForwarding.setMode(UserForwardMode.UForwardNone);
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final DataSource retval = objectUnderTest.getItemSource();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getLastLoginInfoOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(UserAuthType.UAppleAuth);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    final UserRight userRight1 = new UserRight();
    userRight1.setPublicFolderRight(false);
    userRight1.setArchiveFolderRight(false);
    objectUnderTest.setRole(userRight1);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    final EmailForwarding emailForwarding = new EmailForwarding();
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final LastLogin retval = objectUnderTest.getLastLoginInfo();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getLoginNameOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(false);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight = new UserRight();
    userRight.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final String retval = objectUnderTest.getLoginName();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getMigrationOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    final UserRight userRight = new UserRight();
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription(null);
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(0);
    objectUnderTest.setItemSource(null);
    final UserRight userRight1 = new UserRight();
    userRight1.setUserRole(UserRoleType.AccountAdmin);
    userRight1.setArchiveFolderRight(null);
    userRight1.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight1);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(false);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName("");
    final EmailForwarding emailForwarding = new EmailForwarding();
    objectUnderTest.setEmailForwarding(emailForwarding);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final SizeLimit sizeLimit = new SizeLimit();
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final OptionalEntity retval = objectUnderTest.getMigration();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getOutMessageLimitOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId("");
    final UserRight userRight = new UserRight();
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    final UserRight userRight1 = new UserRight();
    userRight1.setArchiveFolderRight(false);
    objectUnderTest.setRole(userRight1);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final SizeLimit retval = objectUnderTest.getOutMessageLimit();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getPasswordOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    userRight.setUserRole(UserRoleType.AccountAdmin);
    userRight.setArchiveFolderRight(null);
    userRight.setPublicFolderRight(false);
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId("");
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(null);
    final UserRight userRight1 = new UserRight();
    objectUnderTest.setGroupRole(userRight1);
    final ItemCountLimit itemCountLimit = new ItemCountLimit(null, 0);
    objectUnderTest.setItemLimit(itemCountLimit);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(null);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final String retval = objectUnderTest.getPassword();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getPublishInGalOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    final ByteValueWithUnits byteValueWithUnits = new ByteValueWithUnits();
    byteValueWithUnits.setUnits(ByteUnits.GigaBytes);
    byteValueWithUnits.setValue(0);
    objectUnderTest.setConsumedSize(byteValueWithUnits);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    final ByteValueWithUnits byteValueWithUnits1 = new ByteValueWithUnits();
    final SizeLimit sizeLimit = new SizeLimit(null, byteValueWithUnits1);
    objectUnderTest.setDiskSizeLimit(sizeLimit);

    // Act
    final Boolean retval = objectUnderTest.getPublishInGal();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getRoleOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    final UserRight userRight = new UserRight();
    objectUnderTest.setEffectiveRole(userRight);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    final SizeLimit sizeLimit = new SizeLimit();
    objectUnderTest.setOutMessageLimit(sizeLimit);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId("");
    objectUnderTest.setPassword(null);
    objectUnderTest.setRole(null);
    objectUnderTest.setFullName(null);
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    final UserRight userRight1 = new UserRight();
    userRight1.setPublicFolderRight(false);
    objectUnderTest.setGroupRole(userRight1);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final UserRight retval = objectUnderTest.getRole();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getUserGroupsOutputNull() {

    // Arrange
    final User objectUnderTest = new User();
    objectUnderTest.setAllowPasswordChange(null);
    objectUnderTest.setCleanOutItems(null);
    objectUnderTest.setCompanyContactId(null);
    objectUnderTest.setEffectiveRole(null);
    objectUnderTest.setDescription("");
    objectUnderTest.setDomainId(null);
    objectUnderTest.setLastLoginInfo(null);
    objectUnderTest.setConsumedSize(null);
    objectUnderTest.setOutMessageLimit(null);
    objectUnderTest.setPublishInGal(null);
    objectUnderTest.setHasDomainRestriction(null);
    objectUnderTest.setAuthType(null);
    objectUnderTest.setAccessPolicy(null);
    objectUnderTest.setId(null);
    objectUnderTest.setPassword(null);
    final UserRight userRight = new UserRight();
    userRight.setArchiveFolderRight(false);
    objectUnderTest.setRole(userRight);
    objectUnderTest.setFullName("");
    objectUnderTest.setIsEnabled(null);
    objectUnderTest.setHomeServer(null);
    objectUnderTest.setConsumedItems(null);
    objectUnderTest.setItemSource(DataSource.DSInternalSource);
    objectUnderTest.setGroupRole(null);
    objectUnderTest.setItemLimit(null);
    objectUnderTest.setEmailAddresses(null);
    objectUnderTest.setUserGroups(null);
    objectUnderTest.setIsWritableByMe(null);
    objectUnderTest.setIsPasswordReversible(false);
    objectUnderTest.setLoginName(null);
    objectUnderTest.setEmailForwarding(null);
    objectUnderTest.setHasDefaultSpamRule(null);
    objectUnderTest.setMigration(null);
    objectUnderTest.setDiskSizeLimit(null);

    // Act
    final UserGroup[] retval = objectUnderTest.getUserGroups();

    // result
    assertNull(retval);
  }
}
