package com.kerio.lib.json.api.im.struct.common;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import com.diffblue.deeptestutils.Reflector;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class ApiExceptionDiffblueTest {

  @Rule public final ExpectedException thrown = ExpectedException.none();
  @Rule public final Timeout globalTimeout = new Timeout(10000);

  /* testedClasses: ApiException */
  // Test generated by Diffblue Deeptest.

  @Test
  public void getCodeOutputNull() {

    // Arrange
    final ApiException objectUnderTest = new ApiException();
    objectUnderTest.setMessageParameters(null);
    objectUnderTest.setMessage(null);
    objectUnderTest.setCode(null);
    Reflector.setField(objectUnderTest, "cause", null);
    Reflector.setField(objectUnderTest, "detailMessage", null);

    // Act
    final Integer retval = objectUnderTest.getCode();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getMessageOutputNull() {

    // Arrange
    final ApiException objectUnderTest = new ApiException();
    objectUnderTest.setMessageParameters(null);
    objectUnderTest.setMessage(null);
    objectUnderTest.setCode(null);
    Reflector.setField(objectUnderTest, "cause", null);
    Reflector.setField(objectUnderTest, "detailMessage", null);

    // Act
    final String retval = objectUnderTest.getMessage();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void getMessageParametersOutputNull() {

    // Arrange
    final ApiException objectUnderTest = new ApiException();
    objectUnderTest.setMessageParameters(null);
    objectUnderTest.setMessage(null);
    objectUnderTest.setCode(null);
    Reflector.setField(objectUnderTest, "cause", null);
    Reflector.setField(objectUnderTest, "detailMessage", null);

    // Act
    final LocalizableMessageParameters retval = objectUnderTest.getMessageParameters();

    // result
    assertNull(retval);
  }

  // Test generated by Diffblue Deeptest.

  @Test
  public void toStringOutputNotNull() {

    // Arrange
    final ApiException objectUnderTest = new ApiException();
    objectUnderTest.setMessageParameters(null);
    objectUnderTest.setMessage("\"");
    objectUnderTest.setCode(3);
    Reflector.setField(objectUnderTest, "cause", null);
    Reflector.setField(objectUnderTest, "detailMessage", null);

    // Act
    final String retval = objectUnderTest.toString();

    // result
    assertEquals("ApiException [message=\", code=3, messageParameters=null]", retval);
  }
}
