/*
 * Copyright 2015 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.methods;

import com.kerio.im.rpcserver.RpcError;
import java.util.logging.Level;
import java.util.logging.Logger;
import com.kerio.im.rpcserver.RpcMethod;
import com.kerio.im.rpcserver.SessionManager;

/**
 *
 * @author oleopold
 */
public class WhoAmI implements RpcMethod {

    private static final Logger LOG = Logger.getLogger(WhoAmI.class.getName());

    @Override
    public String getMethod() {
        return "Session.whoAmI";
    }

    @Override
    public void execute(Request data, Response res, SessionManager sessionManager) {
        if (!sessionManager.verify(data.getSessionID(), data.getToken())) {
            res.error(new RpcError(1000, "Invalid Session ID or Token!"), 403);
            return;
        }
        
        LOG.log(Level.FINE, "Called method \"{0}\" with data: {1}", new Object[]{data.getContent().getMethod(), data.getContent().getParams().toString()});
    }

}
