/*
 * Copyright 2015 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.rpcserver;

import java.util.Objects;

/**
 *
 * @author tskoda
 */
public class Endpoint {
    
    //private static final String RPC_PATH = "/jsonrpc/%1$d/*";
    private static final String RPC_PATH = "/admin/api/jsonrpc/*";

    private final int version;
    private final String path;

    public Endpoint(int version) {
        this.version = version;
        this.path = String.format(RPC_PATH, version);
    }

    public int getVersion() {
        return version;
    }
    
    public String getPath() {
        return path;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 41 * hash + Objects.hashCode(this.path);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Endpoint other = (Endpoint) obj;

        return Objects.equals(this.path, other.path);

    }
    
    
    
}
