/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.kerio.im.rpcserver;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

/**
 *
 * @author jzacek
 */
public class SessionManager {
    
    public static class IDs {
        private final String sessionID;
        private final String token;

        public IDs(String sessionID, String token) {
            this.sessionID = sessionID;
            this.token = token;
        }

        public String getSessionID() {
            return sessionID;
        }

        public String getToken() {
            return token;
        }                
    }
    
    private final Map<String, String> ids = new HashMap<>();

    private String generateUniqueID() {
        String uuid;
        do {
            uuid = UUID.randomUUID().toString();
        } while (ids.containsKey(uuid) || ids.containsValue(uuid));            
        return uuid;
    }

    public IDs getIDs() {
        IDs res = new IDs(generateUniqueID(), generateUniqueID());
        ids.put(res.getSessionID(), res.getToken());
        return res;
    }

    public boolean verify(String sessionID, String token) {
        if (sessionID == null || token == null || ids.get(sessionID) == null) {
            return false;
        }        
        return ids.get(sessionID).equals(token);
    }

    public void removeSessionID(String sessionID) {
        ids.remove(sessionID);
    }

}
