/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase;

import com.kerio.im.common.CustomLevel;
import com.kerio.im.common.OutputStreamToLogger;
import java.io.OutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author tskoda
 */
public class DerbyHandler {

    /** Method name for derby logging output */
    public static final String DERBY_OUTPUT = DerbyHandler.class.getName() + ".derbyOutput";
    /** Derby logging LEVEL */
    private static final Level DERBY_LEVEL = new CustomLevel("DERBY", Level.FINEST.intValue() + 2);

    /**
     * Method for setting default derby log output.
     * @return 
     */
    public static OutputStream derbyOutput() {
        return new OutputStreamToLogger(Logger.getLogger("org.apache.derby"), DERBY_LEVEL);
    }
}
