/*
 *  Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase;

import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import tigase.server.Packet;
import tigase.server.Permissions;

/**
 *
 * @author tskoda
 */
public class PacketLogger {

    private static final Logger LOG = Logger.getLogger(PacketLogger.class.getName());

    public static final Map<String, Integer> counter = new HashMap<String, Integer>();

    public static boolean log(String component, Packet packet) {
	boolean result = false;
	if (packet.getType() != null) {
	    String flag = packet.getPermissions() == Permissions.REMOTE? "R": "";
	    switch (packet.getType()) {
		case set:
		    if (packet.getElement().findChild("iq/si/file") == null) {
			break;
		    }
		case chat:
		    if ((packet.getElement().getCData("message/body/")) == null) {
			break;
		    } 
		    if ((packet.getElement().findChild("message/delay")) != null) {
			flag += "D";
		    }
		case groupchat:
		    long count = count(packet.getStanzaId());
		    //LOG.log(Level.SEVERE, "[{0}] - {1} ('{2}' -> '{3}')", new Object[]{count, component, packet.getStanzaFrom() == null? packet.getPacketFrom(): packet.getStanzaFrom(), packet.getStanzaTo()});
		    LOG.log(Level.SEVERE, "[{0}] - {4} {1} ('{2}' -> '{3}')", new Object[]{count, component, packet.getPacketFrom(), packet.getPacketTo(), flag});
		    LOG.log(Level.SEVERE, "[{0}] - {4} {1} ('{2}' -> '{3}')", new Object[]{count, component, packet.getStanzaFrom(), packet.getStanzaTo(), flag});
		    result = true;
		    break;
	    }
	}
	return result;
    }

    private static Integer count(String stanzaId) {
	synchronized (counter) {
	    if (stanzaId == null) {
		stanzaId = "null";
	    }

	    Integer result = counter.get(stanzaId);
	    result = result != null ? ++result : 1;
	    counter.put(stanzaId, result);
	    return result;
	}
    }

}
