/*
 *  Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase;

import com.kerio.im.core.api.service.PacketType;
import tigase.server.Packet;

/**
 *
 * @author tskoda
 */
public final class PacketResolver {

    public static final String PRESENCE = "presence";

    public static PacketType resolve(Packet source) {
        PacketType result;
        if (source.getType() == null) {
            result = PRESENCE.equals(source.getElemName()) ? PacketType.PRESENCE : PacketType.DEFAULT;
        } else {
            switch (source.getType()) {
                case error:
                    result = PacketType.ERROR;
                    break;
                case available:
                case unavailable:
                case probe:
                case subscribe:
                case subscribed:
                case unsubscribe:
                case unsubscribed:
                    result = PacketType.PRESENCE;
                    break;
                case chat:
                case groupchat:
                case headline:
                case normal:
                    //filter out typing events which are also chat packets
                    result = source.getElemChildren("message/body/") != null ? PacketType.MESSAGE : PacketType.DEFAULT;
                    break;
                default:
                    result = PacketType.DEFAULT;
            }
        }
        return result;
    }
}
