/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase;

import com.kerio.im.common.error.Code;
import com.kerio.im.xmpp.api.XmppException;

/**
 *
 * @author tskoda
 */
public interface RepositoryManager {

    void addRepository(String domain);

    void removeRepository(String domain);
    
    boolean exist(String domain);
    
    public static class DuplicateException extends XmppException {
        
        private static final String MESSAGE = "Repository for domain {0} already exists";

        public DuplicateException(String domain) {
            super(MESSAGE, Code.RESOURCE_ERROR, domain);
        }
    }
    
    public static class NotFoundException extends XmppException {
        
        private static final String MESSAGE = "Repository for domain {0} not found";

        public NotFoundException(String domain) {
            super(MESSAGE, Code.RESOURCE_ERROR, domain);
        }
    }
    
}
