/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.tigase.bridge.IM;

import java.util.Arrays;
import java.util.List;
import tigase.xmpp.BareJID;

/**
 *
 * @author vbystricky
 */
public class UserPresence {

    private final BareJID userID;
    private final List<IMConnection.ClientStatus> clientStatuses;

    public UserPresence(BareJID userID, List<IMConnection.ClientStatus> clientStatuses) {
        this.clientStatuses = clientStatuses;
        this.userID = userID;
    }

    public BareJID getUserID() {
        return userID;
    }

    public List<IMConnection.ClientStatus> getClientStatuses() {
        return clientStatuses;
    }

    @Override
    public String toString() {
        return "User " + userID + " presence status: \"" + Arrays.toString(clientStatuses.toArray()) + "\"";
    }
}
