/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.tigase.bridge;

import com.kerio.im.external.IMContactID;
import com.kerio.im.rpcserver.ISubscription;
import com.kerio.im.rpcserver.ISubscriptionResolver;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author vbystricky
 */
public class IMSubscribctionsMamager implements ISubscriptionResolver {

    private final Map<Integer, IMSubscription> subscribctions;

    public IMSubscribctionsMamager() {
        subscribctions = new HashMap<>();
    }

    public synchronized void addSubscription(Integer subscriptionId, java.lang.Class<?> subsctiptionType, IMContactID subscriber) {
        subscribctions.put(subscriptionId, new IMSubscription(subscriber, subsctiptionType));
    }

    public synchronized void removeSubscription(Integer subscriptionId) {
        subscribctions.remove(subscriptionId);
    }

    public synchronized void clear() {
        subscribctions.clear();
    }

    @Override
    public ISubscription getSubscription(Integer subscriptionId) {
        return subscribctions.get(subscriptionId);
    }
}
