package com.kerio.im.tigase.bridge.communicator;

import com.kerio.im.tigase.bridge.xmpp.IMBridge;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;
import java.util.logging.Level;
import java.util.logging.Logger;
import tigase.server.Packet;

/**
 *
 * @author jzacek
 */
public class PacketResponse {

	private final List<Predicate<Packet>> items = new ArrayList<>();
	private static final Logger LOGGER = Logger.getLogger(PacketResponse.class.getName());
	private boolean hit = false;
	private final String name;

	private PacketResponse(String name) {
		this.name = name;
	}

	public static PacketResponse init(String name) {
		PacketResponse res = new PacketResponse(name);
		return res;
	}

	public boolean check(Packet json) {
		if (items.stream().noneMatch((i) -> (!i.test(json)))) {
			LOGGER.log(Level.FINER, IMBridge.LOG_PREFIX + "Recieved packet: {0}", this.toString());
			this.hit = true;
            return true;
		}
		return false;
	}

	public PacketResponse add(Predicate<Packet> p) {
		items.add(p);
		return this;
	}

	public boolean isHit() {
		return this.hit;
	}

	@Override
	public String toString() {
		return name;
	}
}
