/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.tigase.bridge.xmpp;

import java.util.logging.Level;
import java.util.logging.Logger;
import tigase.xmpp.NoConnectionIdException;
import tigase.xmpp.ResourceValidator;
import tigase.xmpp.XMPPResourceConnection;

/**
 *
 * @author vbystricky
 */
public class ResourceValidatorImpl implements ResourceValidator {

    private static final Logger LOGGER = Logger.getLogger(ResourceValidatorImpl.class.getName());

    @Override
    public boolean isAllowedResource(String resource, XMPPResourceConnection connection) {
        try {
            if (!XmppIdGenerator.isResourceIdInRightFormat(resource) || XmppIdGenerator.isConnectionIdInRightFormat(connection.getConnectionId().getResource())) {
                LOGGER.log(Level.FINE, "Resource {0} is allowed for connection {1}.", new Object[]{resource, connection.toString()});
                return true;
            }
        } catch (NoConnectionIdException ex) {
            LOGGER.log(Level.INFO, "Resource check failed. Connection has no id. Bind of resource {0} is forbiden.", resource);
        }
        LOGGER.log(Level.INFO, "Resource {0} is forbidden for connection {1}.", new Object[]{resource, connection.toString()});
        return false;
    }
}
