/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.configuration;

import com.kerio.im.tigase.DerbyHandler;
import com.kerio.im.tigase.configuration.ConnectConfigurator;

/**
 * 
 * @author tskoda
 */
public enum SystemKey {

    //-Dhome.dir=./ -Dfile.encoding=UTF-8 -Dsun.jnu.encoding=UTF-8 -Djdbc.drivers=org.apache.derby.jdbc.EmbeddedDriver -Dtigase-configurator=com.kerio.connect.xmpp.tigase.ConnectConfigurator -Xmx128M 
    
    FILE_ENCODING("file.encoding", "UTF-8"),
    SUN_ENCODING("sun.jnu.encoding", "UTF-8"),
    JDBC_DRIVERS("jdbc.drivers", "org.apache.derby.jdbc.EmbeddedDriver"),
    TIGASE_CONFIGURATOR("tigase-configurator", ConnectConfigurator.class.getName()),
    DERBY_LOG("derby.stream.error.method", DerbyHandler.DERBY_OUTPUT);
    
    public final String key;
    public final String value;

    private SystemKey(String key, String value) {
        this.key = key;
        this.value = value;
    }

}