/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.configuration.task;


import com.kerio.im.common.Task;
import com.kerio.im.tigase.configuration.SystemKey;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author tskoda
 */
public class ApplySystemProperties implements Task<Properties> {

    private static final Logger LOG = Logger.getLogger(ApplySystemProperties.class.getName());

    @Override
    public void run(Properties properties) {

        LOG.log(Level.CONFIG, "Applying default system properties");

        apply(SystemKey.DERBY_LOG);
        apply(SystemKey.FILE_ENCODING);
        apply(SystemKey.JDBC_DRIVERS);
        apply(SystemKey.SUN_ENCODING);
        apply(SystemKey.TIGASE_CONFIGURATOR);

    }

    protected void apply(SystemKey property, Object... parameters) {
        String value = System.getProperty(property.key);
        
        if (value == null) {
            value = (parameters == null || parameters.length == 0) ? property.value : String.format(property.value, parameters);
            System.setProperty(property.key, value);
        }

    }
}
