/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.tigase.configuration.task;

import com.kerio.im.common.Task;
import com.kerio.im.common.error.Code;
import com.kerio.im.tigase.MessageResourceSelector;
import com.kerio.im.tigase.configuration.PluginConfigurator;
import com.kerio.im.xmpp.api.XmppException;
import tigase.db.TigaseDBException;
import tigase.xmpp.ResourceSelector;

/**
 *
 * @author tskoda
 */
public class InitializeAMP implements Task<PluginConfigurator> {
    
    private final MessageResourceSelector selector;

    public InitializeAMP(MessageResourceSelector selector) {
        this.selector = selector;
    }
    
    @Override
    public void run(PluginConfigurator parameter) {
        try {
            parameter.configure("amp", ResourceSelector.class.getName(), selector);
        } catch (TigaseDBException e) {
            throw new XmppException("Failed to configure {0} plugin", e, Code.INTERNAL_SERVER_ERROR, "amp");
        }
    }
    
}
