/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.configuration.task;

import com.kerio.im.common.Task;
import com.kerio.im.common.error.Code;
import com.kerio.im.core.api.service.AuthService;
import com.kerio.im.tigase.configuration.PluginConfigurator;
import com.kerio.im.tigase.plugin.DisconnectPlugin;
import com.kerio.im.xmpp.api.XmppException;
import java.util.logging.Level;
import java.util.logging.Logger;
import tigase.db.TigaseDBException;

/**
 *
 * @author tskoda
 */
public class InitializeDisconnectPlugin implements Task<AuthService> {
    private static final Logger LOG = Logger.getLogger(InitializeDisconnectPlugin.class.getName());
    
    private final PluginConfigurator configurator;

    public InitializeDisconnectPlugin(PluginConfigurator configurator) {
        this.configurator = configurator;
    }

    @Override
    public void run(AuthService authService) {
        try {
           LOG.log(Level.CONFIG, "Starting clients disconnection listener");
           configurator.configure(DisconnectPlugin.ID, AuthService.class.getName(), authService);
        } catch (TigaseDBException e) {
            throw new XmppException("Starting clients disconnection listener failed", e, Code.INTERNAL_SERVER_ERROR);
        }
    }   
}
