/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.configuration.task;

import com.kerio.im.common.Task;
import com.kerio.im.common.error.Code;
import com.kerio.im.core.api.CoreService;
import com.kerio.im.core.api.service.AccessPolicyService;
import com.kerio.im.tigase.configuration.PluginConfigurator;
import com.kerio.im.tigase.plugin.DomainFilterPlugin;
import com.kerio.im.xmpp.api.XmppException;
import tigase.db.TigaseDBException;

/**
 *
 * @author tskoda
 */
public class InitializeDomainFilter implements Task<CoreService> {

    private final PluginConfigurator configurator;

    public InitializeDomainFilter(PluginConfigurator configurator) {
        this.configurator = configurator;
    }

    @Override
    public void run(CoreService coreService) {
        try {
            this.configurator.configure(DomainFilterPlugin.ID, AccessPolicyService.class.getName(), coreService.accessPolicy());
        } catch (TigaseDBException ex) {
            throw new XmppException("Domain filter configuration failed", ex, Code.INTERNAL_SERVER_ERROR);
        }
    }
}
