/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.tigase.configuration.task;

import com.kerio.im.common.Task;
import com.kerio.im.common.error.Code;
import com.kerio.im.core.api.CoreService;
import com.kerio.im.core.api.service.ServiceBus;
import com.kerio.im.tigase.bridge.IMBridgePlugin;
import com.kerio.im.tigase.configuration.PluginConfigurator;
import com.kerio.im.xmpp.api.XmppException;
import tigase.db.TigaseDBException;

/**
 *
 * @author vbystricky
 */
public class InitiliazeIMBridgePlugin implements Task<CoreService> {

    private final PluginConfigurator configurator;

    public InitiliazeIMBridgePlugin(PluginConfigurator configurator) {
        this.configurator = configurator;
    }

    @Override
    public void run(CoreService coreService) {
        try {
            this.configurator.configure(IMBridgePlugin.ID, ServiceBus.class.getName(), coreService.bus());
        } catch (TigaseDBException ex) {
            throw new XmppException("IMBridgePlugin configuration failed", ex, Code.INTERNAL_SERVER_ERROR);
        }
    }
}
