/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.configuration.task;

import com.kerio.im.common.Task;
import com.kerio.im.common.error.Code;
import com.kerio.im.tigase.auth.ConnectSaslProvider;
import com.kerio.im.xmpp.api.XmppException;
import java.security.Security;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author tskoda
 */
public class InstallSasl implements Task<Properties> {
    
    private static final Logger LOG = Logger.getLogger(InstallSasl.class.getName());

    @Override
    public void run(Properties properties) {
        LOG.log(Level.CONFIG, "Overriding SASL provider");
        int possition = Security.insertProviderAt(new ConnectSaslProvider(), 6);

        if (possition == -1) {
            throw new XmppException("Overriding SASL provider failed", Code.INTERNAL_SERVER_ERROR);
        }
    }
}
