/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.derby;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 *
 * @author tskoda
 */
public final class StoredProcedure {

    private StoredProcedure() {
    }

    /**
     * Method description
     *
     *
     * @param userId
     * @param userPw
     * @param data
     *
     * @throws SQLException
     */
    public static void kAddUser(String userId, String userPw, int enabled, int visible, ResultSet[] data)
            throws SQLException {
        Connection conn = DriverManager.getConnection("jdbc:default:connection");

        conn.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);


        try {
            // check whether user exists
            PreparedStatement ps_check = conn.prepareStatement("select uid from tig_users where lower(user_id)=?");
            ps_check.setString(1, userId.toLowerCase());
            ResultSet rs_check = ps_check.executeQuery();
            if (rs_check.next()) {
                return;
            }
            PreparedStatement ps =
                    conn.prepareStatement("insert into tig_users (user_id, user_pw, k_status, k_gal) values (?, ?, ?, ?)",
                    Statement.RETURN_GENERATED_KEYS);

            ps.setString(1, userId);
            ps.setString(2, userPw);
            ps.setInt(3, enabled);
            ps.setInt(4, visible);
            ps.executeUpdate();

            ResultSet rs = ps.getGeneratedKeys();

            rs.next();

            long generatedKey = rs.getLong(1);
            PreparedStatement ps3 = conn.prepareStatement("select uid from tig_users where uid=?");

            ps3.setLong(1, generatedKey);
            data[0] = ps3.executeQuery();

            PreparedStatement ps2 =
                    conn.prepareStatement("insert into tig_nodes (parent_nid, uid, node) values (NULL, ?, 'root')");

            ps2.setLong(1, generatedKey);
            ps2.executeUpdate();

            if (null == userPw) {
                PreparedStatement ps4 =
                        conn.prepareStatement("update tig_users set account_status = -1 where uid = ?");

                ps4.setLong(1, generatedKey);
                ps4.executeUpdate();
            }
        } catch (SQLException e) {

            // e.printStackTrace();
            // log.log(Level.SEVERE, "SP error", e);
            throw e;
        } finally {
            conn.close();
        }
    }
}
