/*
 *  Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.plugin;

import com.kerio.im.tigase.ClientResolver;
import java.util.Map;
import java.util.Queue;
import tigase.db.NonAuthUserRepository;
import tigase.server.Packet;
import tigase.xmpp.XMPPPreprocessorIfc;
import tigase.xmpp.XMPPProcessor;
import tigase.xmpp.XMPPResourceConnection;

/**
 *
 * @author tskoda
 */
public class ClientTypeFilter extends XMPPProcessor implements XMPPPreprocessorIfc {

    public static final String ID = "connect-client-resolver";
    private static final String[] ELEMENTS = {ALL};
    private static final String[] XMLNS = {ALL};
    private static final boolean PASS = false;

    @Override
    public String id() {
        return ID;
    }

    @Override
    public String[] supElements() {
        return ELEMENTS;
    }

    @Override
    public String[] supNamespaces() {
        return XMLNS;
    }

    @Override
    public boolean preProcess(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String, Object> settings) {
        String id;
        if ((session != null) && (packet != null) && ((id = packet.getAttribute("id")) != null)) {
            session.putSessionData(ClientResolver.CLIENT_TYPE, ClientResolver.ClientType.resolve(id));
        }

        return PASS;
    }

}
