/*
 *  Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.roster;

import java.util.List;
import java.util.Map;
import tigase.xml.Element;
import tigase.xmpp.JID;
import tigase.xmpp.NotAuthorizedException;
import tigase.xmpp.XMPPResourceConnection;
import tigase.xmpp.impl.DynamicRosterIfc;

/**
 *
 * @author tskoda
 */
public class DynamicDomainRosterHandle implements DynamicRosterIfc {

    private IDynamicDomainRoster roster;

    public DynamicDomainRosterHandle() {
    }

    @Override
    public void setItemExtraData(Element item) {
        roster.setItemExtraData(item);
    }

    @Override
    public Element getItemExtraData(Element item) {
        return roster.getItemExtraData(item);
    }

    @Override
    public void init(Map<String, Object> props) {
        if (this.roster == null) {
            roster = (IDynamicDomainRoster) props.get(IDynamicDomainRoster.class.getName());
        }
    }

    @Override
    public void init(String par) {
        //empty
    }

    @Override
    public JID[] getBuddies(XMPPResourceConnection session) throws NotAuthorizedException {
        return roster.getBuddies(session);
    }

    @Override
    public Element getBuddyItem(XMPPResourceConnection session, JID buddy) throws NotAuthorizedException {
        return roster.getBuddyItem(session, buddy);
    }

    @Override
    public List<Element> getRosterItems(XMPPResourceConnection session) throws NotAuthorizedException {
        return roster.getRosterItems(session);
    }

}
