/*
 * Copyright 2014 Kerio Technologies s.r.o. All rights reserved
 */
package com.kerio.im.tigase.bridge.xmpp;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author oleopold
 */
public class VariableSleeperTest {
    final static long[] REFERENCE_TIME_LIST = {1000, 5000, 10000, 20000, 40000, 60000, 60000, 60000, 60000, 60000, 60000, 60000, 60000, 60000, 60000};

    public VariableSleeperTest() {
    }

    @Test
    public void testSleep() throws Exception {
        System.out.println("sleep");
        VariableSleeper instance = new VariableSleeper();

        for (int i = 0; i < 3; ++i) {
            long nexSleepDuration = instance.getNextSleepDuration();
            long start = System.nanoTime();
            instance.sleep();
            long elapsedTime = (System.nanoTime() - start) / 1000000;
            if (Math.abs(elapsedTime - nexSleepDuration) > 50) {
                fail("Sleep test failed for interval " + Long.toString(nexSleepDuration) + ", but it was " + Long.toString(elapsedTime) + ".");
            }
            if (nexSleepDuration != REFERENCE_TIME_LIST[i]) {
                fail("Sleeper interval test failed for sleep intervat " + Long.toString(nexSleepDuration) + ", expected value is " + Long.toString(REFERENCE_TIME_LIST[i]) + ".");
            }
        }
    }

    @Test
    public void incrementInterval() throws Exception {
        System.out.println("incrementInterval");
        VariableSleeper instance = new VariableSleeper();

        for (int i = 0; i < REFERENCE_TIME_LIST.length; ++i) {
            long nexSleepDuration = instance.getNextSleepDuration();
            if (nexSleepDuration != REFERENCE_TIME_LIST[i]) {
                fail("Sleeper interval test failed for sleep intervat " + Long.toString(nexSleepDuration) + ", expected value is " + Long.toString(REFERENCE_TIME_LIST[i]) + ".");
            }
            instance.incrementInterval();
        }
    }

}
