/*
 *  Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.roster;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import tigase.xmpp.BareJID;

/**
 *
 * @author tskoda
 */
public class TestFilter<T extends PacketBuilder.SingleChangePacket> implements RosterNotify.Filter<T> {

    private final Set<BareJID> block = new HashSet<BareJID>();
    private final Map<BareJID, T> pass = new HashMap<BareJID, T>();
    
    private int calls = 0;
    
    public void block(BareJID... users) {
        this.block.addAll(Arrays.asList(users));
    }

    public void passWith(BareJID user, T result) {
        this.pass.put(user, result);
    }

    @Override
    public T pass(BareJID recipient, T packet) {
        calls++;
        T result = packet; //by default allow all
        
        if (this.block.contains(recipient)) {
            result = null;
        } else if (this.pass.containsKey(recipient)) {
            result = this.pass.get(recipient);
        }

        return result;
    }

    public int getCalls() {
        return calls;
    }
    
}
