/*
 *  Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.tigase.user;

import com.kerio.im.tigase.PacketSender;
import static com.kerio.im.tigase.user.XmppUsersStoreAbstract.as;
import java.util.HashMap;
import java.util.Map;
import java.util.Queue;
import tigase.server.Packet;
import tigase.xmpp.BareJID;
import tigase.xmpp.JID;

/**
 *
 * @author tskoda
 */
public class TestPacketSender implements PacketSender {

    private final Map<JID, Packet> all = new HashMap<JID, Packet>();

    @Override
    public boolean processOutPacket(Packet packet) {
        this.all.put(packet.getPacketTo(), packet);
        return true;
    }

    @Override
    public boolean processOutPacket(Queue<Packet> packets) {
        for (Packet packet : packets) {
            this.all.put(packet.getPacketTo(), packet);
        }
        return true;
    }

    public Packet get(int user, int resource) {
        JID jid = as.jid(user, resource);
        return this.all.get(jid);
    }
    
        public Packet get(BareJID user, int resource) {
        JID jid = as.jid(user, resource);
        return this.all.get(jid);
    }

    public int count() {
        return this.all.size();
    }
}
