/*
 * Copyright 2013 Kerio Technologies s.r.o. All rights reserved.
 */
package com.kerio.im.xmpp.api;

import com.kerio.im.common.RegisterAs;
import com.kerio.im.common.Service;
import com.kerio.im.core.api.CoreService;
import java.util.Map;

/**
 *
 * @author tskoda
 */
@RegisterAs(interfaces=XmppServiceFactory.class)
public interface XmppServiceFactory extends Service {
    
    /**
     * Return instance of "running" XMPPServer. Not thread-safe. Not designed
     * to be called multiple times.
     * @param properties command line parameters
     * @param coreService core xmpp service
     * @return instance of XMPPServer, never returns null.
     */
    XmppService get(Map<String, String> properties, CoreService coreService);
    
}
