/*
 * Copyright 2010 Kerio Technologies s.r.o. All rights reserved
 */
package tigase.xmpp;

import java.util.Set;

/**
 *
 * @author tskoda
 */
public interface ResourceSelector {
    
    class CanNotDeliver extends XMPPException {
        
        public enum Action {
            ignore,
            serviceUnavailible,
        }

        private final Action action;

        public CanNotDeliver(Action action, String reason) {
            super(reason);
            this.action = action;
        }

        public Action getAction() {
            return action;
        }
    } 

    /**
     * Returns set of resources to which message should be delivered. When set is emptu
     * message has to be stored for offline delivery.
     * @param to
     * @param type
     * @param session
     * @return
     * @throws tigase.xmpp.ResourceSelector.CanNotDeliver 
     */
    Set<XMPPResourceConnection> preferredResources(JID to, StanzaType type, XMPPSession session) throws CanNotDeliver;
}
