package tigase.io;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;
import static tigase.io.SampleSocketThread.help;
import org.junit.Test;

public class SampleSocketThreadHelpTest {

    private static final String NEW_LINE = System.lineSeparator();
    static final String HELP_VALUE = NEW_LINE + "Parameters:" + NEW_LINE 
            + " -?                this help message" + NEW_LINE
            + " -h hostname       host name" + NEW_LINE 
            + " -p port           port number" + NEW_LINE
            + " -ssl              turn SSL on for all connections" + NEW_LINE
            + " -f file           file with content to send to remote host" + NEW_LINE
            + " -c                continuous sending file content" + NEW_LINE
            + " -t millis         delay between sending file content" + NEW_LINE
            + " -v                prints server version info" + NEW_LINE
            + " -d [true|false]   turn on|off debug mode" + NEW_LINE;

    @Test
    public void givenClassWhenHelpRunsThenExpectedResultIsReturned() throws Exception {
        // Act
        String result = help();

        // Assert
        assertThat(result, is(HELP_VALUE));
    }
}
